//go:build !ignore_autogenerated
// +build !ignore_autogenerated

// Copyright (c) 2023 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0

// Code generated by conversion-gen. DO NOT EDIT.

package v1alpha1

import (
	json "encoding/json"
	unsafe "unsafe"

	v1alpha2 "github.com/vmware-tanzu/vm-operator/api/v1alpha2"
	common "github.com/vmware-tanzu/vm-operator/api/v1alpha2/common"
	corev1 "k8s.io/api/core/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	conversion "k8s.io/apimachinery/pkg/conversion"
	runtime "k8s.io/apimachinery/pkg/runtime"
)

func init() {
	localSchemeBuilder.Register(RegisterConversions)
}

// RegisterConversions adds conversion functions to the given scheme.
// Public to allow building arbitrary schemes.
func RegisterConversions(s *runtime.Scheme) error {
	if err := s.AddGeneratedConversionFunc((*ClusterVirtualMachineImage)(nil), (*v1alpha2.ClusterVirtualMachineImage)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_ClusterVirtualMachineImage_To_v1alpha2_ClusterVirtualMachineImage(a.(*ClusterVirtualMachineImage), b.(*v1alpha2.ClusterVirtualMachineImage), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.ClusterVirtualMachineImage)(nil), (*ClusterVirtualMachineImage)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_ClusterVirtualMachineImage_To_v1alpha1_ClusterVirtualMachineImage(a.(*v1alpha2.ClusterVirtualMachineImage), b.(*ClusterVirtualMachineImage), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*ClusterVirtualMachineImageList)(nil), (*v1alpha2.ClusterVirtualMachineImageList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_ClusterVirtualMachineImageList_To_v1alpha2_ClusterVirtualMachineImageList(a.(*ClusterVirtualMachineImageList), b.(*v1alpha2.ClusterVirtualMachineImageList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.ClusterVirtualMachineImageList)(nil), (*ClusterVirtualMachineImageList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_ClusterVirtualMachineImageList_To_v1alpha1_ClusterVirtualMachineImageList(a.(*v1alpha2.ClusterVirtualMachineImageList), b.(*ClusterVirtualMachineImageList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*DynamicDirectPathIODevice)(nil), (*v1alpha2.DynamicDirectPathIODevice)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_DynamicDirectPathIODevice_To_v1alpha2_DynamicDirectPathIODevice(a.(*DynamicDirectPathIODevice), b.(*v1alpha2.DynamicDirectPathIODevice), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.DynamicDirectPathIODevice)(nil), (*DynamicDirectPathIODevice)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_DynamicDirectPathIODevice_To_v1alpha1_DynamicDirectPathIODevice(a.(*v1alpha2.DynamicDirectPathIODevice), b.(*DynamicDirectPathIODevice), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*GuestHeartbeatAction)(nil), (*v1alpha2.GuestHeartbeatAction)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_GuestHeartbeatAction_To_v1alpha2_GuestHeartbeatAction(a.(*GuestHeartbeatAction), b.(*v1alpha2.GuestHeartbeatAction), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.GuestHeartbeatAction)(nil), (*GuestHeartbeatAction)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_GuestHeartbeatAction_To_v1alpha1_GuestHeartbeatAction(a.(*v1alpha2.GuestHeartbeatAction), b.(*GuestHeartbeatAction), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*InstanceStorage)(nil), (*v1alpha2.InstanceStorage)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_InstanceStorage_To_v1alpha2_InstanceStorage(a.(*InstanceStorage), b.(*v1alpha2.InstanceStorage), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.InstanceStorage)(nil), (*InstanceStorage)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_InstanceStorage_To_v1alpha1_InstanceStorage(a.(*v1alpha2.InstanceStorage), b.(*InstanceStorage), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*InstanceStorageVolume)(nil), (*v1alpha2.InstanceStorageVolume)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_InstanceStorageVolume_To_v1alpha2_InstanceStorageVolume(a.(*InstanceStorageVolume), b.(*v1alpha2.InstanceStorageVolume), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.InstanceStorageVolume)(nil), (*InstanceStorageVolume)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_InstanceStorageVolume_To_v1alpha1_InstanceStorageVolume(a.(*v1alpha2.InstanceStorageVolume), b.(*InstanceStorageVolume), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*LoadBalancerIngress)(nil), (*v1alpha2.LoadBalancerIngress)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_LoadBalancerIngress_To_v1alpha2_LoadBalancerIngress(a.(*LoadBalancerIngress), b.(*v1alpha2.LoadBalancerIngress), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.LoadBalancerIngress)(nil), (*LoadBalancerIngress)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_LoadBalancerIngress_To_v1alpha1_LoadBalancerIngress(a.(*v1alpha2.LoadBalancerIngress), b.(*LoadBalancerIngress), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*LoadBalancerStatus)(nil), (*v1alpha2.LoadBalancerStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_LoadBalancerStatus_To_v1alpha2_LoadBalancerStatus(a.(*LoadBalancerStatus), b.(*v1alpha2.LoadBalancerStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.LoadBalancerStatus)(nil), (*LoadBalancerStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_LoadBalancerStatus_To_v1alpha1_LoadBalancerStatus(a.(*v1alpha2.LoadBalancerStatus), b.(*LoadBalancerStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*NetworkDeviceStatus)(nil), (*v1alpha2.NetworkDeviceStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_NetworkDeviceStatus_To_v1alpha2_NetworkDeviceStatus(a.(*NetworkDeviceStatus), b.(*v1alpha2.NetworkDeviceStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.NetworkDeviceStatus)(nil), (*NetworkDeviceStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_NetworkDeviceStatus_To_v1alpha1_NetworkDeviceStatus(a.(*v1alpha2.NetworkDeviceStatus), b.(*NetworkDeviceStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*NetworkStatus)(nil), (*v1alpha2.NetworkStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_NetworkStatus_To_v1alpha2_NetworkStatus(a.(*NetworkStatus), b.(*v1alpha2.NetworkStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.NetworkStatus)(nil), (*NetworkStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_NetworkStatus_To_v1alpha1_NetworkStatus(a.(*v1alpha2.NetworkStatus), b.(*NetworkStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*ResourcePoolSpec)(nil), (*v1alpha2.ResourcePoolSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_ResourcePoolSpec_To_v1alpha2_ResourcePoolSpec(a.(*ResourcePoolSpec), b.(*v1alpha2.ResourcePoolSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.ResourcePoolSpec)(nil), (*ResourcePoolSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_ResourcePoolSpec_To_v1alpha1_ResourcePoolSpec(a.(*v1alpha2.ResourcePoolSpec), b.(*ResourcePoolSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*TCPSocketAction)(nil), (*v1alpha2.TCPSocketAction)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_TCPSocketAction_To_v1alpha2_TCPSocketAction(a.(*TCPSocketAction), b.(*v1alpha2.TCPSocketAction), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.TCPSocketAction)(nil), (*TCPSocketAction)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_TCPSocketAction_To_v1alpha1_TCPSocketAction(a.(*v1alpha2.TCPSocketAction), b.(*TCPSocketAction), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VGPUDevice)(nil), (*v1alpha2.VGPUDevice)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VGPUDevice_To_v1alpha2_VGPUDevice(a.(*VGPUDevice), b.(*v1alpha2.VGPUDevice), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VGPUDevice)(nil), (*VGPUDevice)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VGPUDevice_To_v1alpha1_VGPUDevice(a.(*v1alpha2.VGPUDevice), b.(*VGPUDevice), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualDevices)(nil), (*v1alpha2.VirtualDevices)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualDevices_To_v1alpha2_VirtualDevices(a.(*VirtualDevices), b.(*v1alpha2.VirtualDevices), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualDevices)(nil), (*VirtualDevices)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualDevices_To_v1alpha1_VirtualDevices(a.(*v1alpha2.VirtualDevices), b.(*VirtualDevices), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachine)(nil), (*v1alpha2.VirtualMachine)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachine_To_v1alpha2_VirtualMachine(a.(*VirtualMachine), b.(*v1alpha2.VirtualMachine), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachine)(nil), (*VirtualMachine)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachine_To_v1alpha1_VirtualMachine(a.(*v1alpha2.VirtualMachine), b.(*VirtualMachine), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineClass)(nil), (*v1alpha2.VirtualMachineClass)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineClass_To_v1alpha2_VirtualMachineClass(a.(*VirtualMachineClass), b.(*v1alpha2.VirtualMachineClass), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineClass)(nil), (*VirtualMachineClass)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineClass_To_v1alpha1_VirtualMachineClass(a.(*v1alpha2.VirtualMachineClass), b.(*VirtualMachineClass), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineClassHardware)(nil), (*v1alpha2.VirtualMachineClassHardware)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineClassHardware_To_v1alpha2_VirtualMachineClassHardware(a.(*VirtualMachineClassHardware), b.(*v1alpha2.VirtualMachineClassHardware), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineClassHardware)(nil), (*VirtualMachineClassHardware)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineClassHardware_To_v1alpha1_VirtualMachineClassHardware(a.(*v1alpha2.VirtualMachineClassHardware), b.(*VirtualMachineClassHardware), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineClassList)(nil), (*v1alpha2.VirtualMachineClassList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineClassList_To_v1alpha2_VirtualMachineClassList(a.(*VirtualMachineClassList), b.(*v1alpha2.VirtualMachineClassList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineClassList)(nil), (*VirtualMachineClassList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineClassList_To_v1alpha1_VirtualMachineClassList(a.(*v1alpha2.VirtualMachineClassList), b.(*VirtualMachineClassList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineClassPolicies)(nil), (*v1alpha2.VirtualMachineClassPolicies)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineClassPolicies_To_v1alpha2_VirtualMachineClassPolicies(a.(*VirtualMachineClassPolicies), b.(*v1alpha2.VirtualMachineClassPolicies), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineClassPolicies)(nil), (*VirtualMachineClassPolicies)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineClassPolicies_To_v1alpha1_VirtualMachineClassPolicies(a.(*v1alpha2.VirtualMachineClassPolicies), b.(*VirtualMachineClassPolicies), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineClassResources)(nil), (*v1alpha2.VirtualMachineClassResources)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineClassResources_To_v1alpha2_VirtualMachineClassResources(a.(*VirtualMachineClassResources), b.(*v1alpha2.VirtualMachineClassResources), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineClassResources)(nil), (*VirtualMachineClassResources)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineClassResources_To_v1alpha1_VirtualMachineClassResources(a.(*v1alpha2.VirtualMachineClassResources), b.(*VirtualMachineClassResources), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineClassSpec)(nil), (*v1alpha2.VirtualMachineClassSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineClassSpec_To_v1alpha2_VirtualMachineClassSpec(a.(*VirtualMachineClassSpec), b.(*v1alpha2.VirtualMachineClassSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineClassSpec)(nil), (*VirtualMachineClassSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineClassSpec_To_v1alpha1_VirtualMachineClassSpec(a.(*v1alpha2.VirtualMachineClassSpec), b.(*VirtualMachineClassSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineClassStatus)(nil), (*v1alpha2.VirtualMachineClassStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineClassStatus_To_v1alpha2_VirtualMachineClassStatus(a.(*VirtualMachineClassStatus), b.(*v1alpha2.VirtualMachineClassStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineImage)(nil), (*v1alpha2.VirtualMachineImage)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineImage_To_v1alpha2_VirtualMachineImage(a.(*VirtualMachineImage), b.(*v1alpha2.VirtualMachineImage), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineImage)(nil), (*VirtualMachineImage)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineImage_To_v1alpha1_VirtualMachineImage(a.(*v1alpha2.VirtualMachineImage), b.(*VirtualMachineImage), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineImageList)(nil), (*v1alpha2.VirtualMachineImageList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineImageList_To_v1alpha2_VirtualMachineImageList(a.(*VirtualMachineImageList), b.(*v1alpha2.VirtualMachineImageList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineImageList)(nil), (*VirtualMachineImageList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineImageList_To_v1alpha1_VirtualMachineImageList(a.(*v1alpha2.VirtualMachineImageList), b.(*VirtualMachineImageList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineImageOSInfo)(nil), (*v1alpha2.VirtualMachineImageOSInfo)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineImageOSInfo_To_v1alpha2_VirtualMachineImageOSInfo(a.(*VirtualMachineImageOSInfo), b.(*v1alpha2.VirtualMachineImageOSInfo), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineImageProductInfo)(nil), (*v1alpha2.VirtualMachineImageProductInfo)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineImageProductInfo_To_v1alpha2_VirtualMachineImageProductInfo(a.(*VirtualMachineImageProductInfo), b.(*v1alpha2.VirtualMachineImageProductInfo), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineImageProductInfo)(nil), (*VirtualMachineImageProductInfo)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineImageProductInfo_To_v1alpha1_VirtualMachineImageProductInfo(a.(*v1alpha2.VirtualMachineImageProductInfo), b.(*VirtualMachineImageProductInfo), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineImageSpec)(nil), (*VirtualMachineImageSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineImageSpec_To_v1alpha1_VirtualMachineImageSpec(a.(*v1alpha2.VirtualMachineImageSpec), b.(*VirtualMachineImageSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineList)(nil), (*v1alpha2.VirtualMachineList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineList_To_v1alpha2_VirtualMachineList(a.(*VirtualMachineList), b.(*v1alpha2.VirtualMachineList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineList)(nil), (*VirtualMachineList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineList_To_v1alpha1_VirtualMachineList(a.(*v1alpha2.VirtualMachineList), b.(*VirtualMachineList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachinePublishRequest)(nil), (*v1alpha2.VirtualMachinePublishRequest)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachinePublishRequest_To_v1alpha2_VirtualMachinePublishRequest(a.(*VirtualMachinePublishRequest), b.(*v1alpha2.VirtualMachinePublishRequest), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachinePublishRequest)(nil), (*VirtualMachinePublishRequest)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachinePublishRequest_To_v1alpha1_VirtualMachinePublishRequest(a.(*v1alpha2.VirtualMachinePublishRequest), b.(*VirtualMachinePublishRequest), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachinePublishRequestList)(nil), (*v1alpha2.VirtualMachinePublishRequestList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachinePublishRequestList_To_v1alpha2_VirtualMachinePublishRequestList(a.(*VirtualMachinePublishRequestList), b.(*v1alpha2.VirtualMachinePublishRequestList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachinePublishRequestList)(nil), (*VirtualMachinePublishRequestList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachinePublishRequestList_To_v1alpha1_VirtualMachinePublishRequestList(a.(*v1alpha2.VirtualMachinePublishRequestList), b.(*VirtualMachinePublishRequestList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachinePublishRequestSource)(nil), (*v1alpha2.VirtualMachinePublishRequestSource)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachinePublishRequestSource_To_v1alpha2_VirtualMachinePublishRequestSource(a.(*VirtualMachinePublishRequestSource), b.(*v1alpha2.VirtualMachinePublishRequestSource), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachinePublishRequestSource)(nil), (*VirtualMachinePublishRequestSource)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachinePublishRequestSource_To_v1alpha1_VirtualMachinePublishRequestSource(a.(*v1alpha2.VirtualMachinePublishRequestSource), b.(*VirtualMachinePublishRequestSource), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachinePublishRequestSpec)(nil), (*v1alpha2.VirtualMachinePublishRequestSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachinePublishRequestSpec_To_v1alpha2_VirtualMachinePublishRequestSpec(a.(*VirtualMachinePublishRequestSpec), b.(*v1alpha2.VirtualMachinePublishRequestSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachinePublishRequestSpec)(nil), (*VirtualMachinePublishRequestSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachinePublishRequestSpec_To_v1alpha1_VirtualMachinePublishRequestSpec(a.(*v1alpha2.VirtualMachinePublishRequestSpec), b.(*VirtualMachinePublishRequestSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachinePublishRequestStatus)(nil), (*v1alpha2.VirtualMachinePublishRequestStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachinePublishRequestStatus_To_v1alpha2_VirtualMachinePublishRequestStatus(a.(*VirtualMachinePublishRequestStatus), b.(*v1alpha2.VirtualMachinePublishRequestStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachinePublishRequestStatus)(nil), (*VirtualMachinePublishRequestStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachinePublishRequestStatus_To_v1alpha1_VirtualMachinePublishRequestStatus(a.(*v1alpha2.VirtualMachinePublishRequestStatus), b.(*VirtualMachinePublishRequestStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachinePublishRequestTarget)(nil), (*v1alpha2.VirtualMachinePublishRequestTarget)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachinePublishRequestTarget_To_v1alpha2_VirtualMachinePublishRequestTarget(a.(*VirtualMachinePublishRequestTarget), b.(*v1alpha2.VirtualMachinePublishRequestTarget), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachinePublishRequestTarget)(nil), (*VirtualMachinePublishRequestTarget)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachinePublishRequestTarget_To_v1alpha1_VirtualMachinePublishRequestTarget(a.(*v1alpha2.VirtualMachinePublishRequestTarget), b.(*VirtualMachinePublishRequestTarget), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachinePublishRequestTargetItem)(nil), (*v1alpha2.VirtualMachinePublishRequestTargetItem)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachinePublishRequestTargetItem_To_v1alpha2_VirtualMachinePublishRequestTargetItem(a.(*VirtualMachinePublishRequestTargetItem), b.(*v1alpha2.VirtualMachinePublishRequestTargetItem), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachinePublishRequestTargetItem)(nil), (*VirtualMachinePublishRequestTargetItem)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachinePublishRequestTargetItem_To_v1alpha1_VirtualMachinePublishRequestTargetItem(a.(*v1alpha2.VirtualMachinePublishRequestTargetItem), b.(*VirtualMachinePublishRequestTargetItem), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachinePublishRequestTargetLocation)(nil), (*v1alpha2.VirtualMachinePublishRequestTargetLocation)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachinePublishRequestTargetLocation_To_v1alpha2_VirtualMachinePublishRequestTargetLocation(a.(*VirtualMachinePublishRequestTargetLocation), b.(*v1alpha2.VirtualMachinePublishRequestTargetLocation), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachinePublishRequestTargetLocation)(nil), (*VirtualMachinePublishRequestTargetLocation)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachinePublishRequestTargetLocation_To_v1alpha1_VirtualMachinePublishRequestTargetLocation(a.(*v1alpha2.VirtualMachinePublishRequestTargetLocation), b.(*VirtualMachinePublishRequestTargetLocation), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineResourceSpec)(nil), (*v1alpha2.VirtualMachineResourceSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineResourceSpec_To_v1alpha2_VirtualMachineResourceSpec(a.(*VirtualMachineResourceSpec), b.(*v1alpha2.VirtualMachineResourceSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineResourceSpec)(nil), (*VirtualMachineResourceSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineResourceSpec_To_v1alpha1_VirtualMachineResourceSpec(a.(*v1alpha2.VirtualMachineResourceSpec), b.(*VirtualMachineResourceSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineService)(nil), (*v1alpha2.VirtualMachineService)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineService_To_v1alpha2_VirtualMachineService(a.(*VirtualMachineService), b.(*v1alpha2.VirtualMachineService), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineService)(nil), (*VirtualMachineService)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineService_To_v1alpha1_VirtualMachineService(a.(*v1alpha2.VirtualMachineService), b.(*VirtualMachineService), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineServiceList)(nil), (*v1alpha2.VirtualMachineServiceList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineServiceList_To_v1alpha2_VirtualMachineServiceList(a.(*VirtualMachineServiceList), b.(*v1alpha2.VirtualMachineServiceList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineServiceList)(nil), (*VirtualMachineServiceList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineServiceList_To_v1alpha1_VirtualMachineServiceList(a.(*v1alpha2.VirtualMachineServiceList), b.(*VirtualMachineServiceList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineServicePort)(nil), (*v1alpha2.VirtualMachineServicePort)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineServicePort_To_v1alpha2_VirtualMachineServicePort(a.(*VirtualMachineServicePort), b.(*v1alpha2.VirtualMachineServicePort), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineServicePort)(nil), (*VirtualMachineServicePort)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineServicePort_To_v1alpha1_VirtualMachineServicePort(a.(*v1alpha2.VirtualMachineServicePort), b.(*VirtualMachineServicePort), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineServiceSpec)(nil), (*v1alpha2.VirtualMachineServiceSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineServiceSpec_To_v1alpha2_VirtualMachineServiceSpec(a.(*VirtualMachineServiceSpec), b.(*v1alpha2.VirtualMachineServiceSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineServiceSpec)(nil), (*VirtualMachineServiceSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineServiceSpec_To_v1alpha1_VirtualMachineServiceSpec(a.(*v1alpha2.VirtualMachineServiceSpec), b.(*VirtualMachineServiceSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineServiceStatus)(nil), (*v1alpha2.VirtualMachineServiceStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineServiceStatus_To_v1alpha2_VirtualMachineServiceStatus(a.(*VirtualMachineServiceStatus), b.(*v1alpha2.VirtualMachineServiceStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineServiceStatus)(nil), (*VirtualMachineServiceStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineServiceStatus_To_v1alpha1_VirtualMachineServiceStatus(a.(*v1alpha2.VirtualMachineServiceStatus), b.(*VirtualMachineServiceStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineSetResourcePolicy)(nil), (*v1alpha2.VirtualMachineSetResourcePolicy)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineSetResourcePolicy_To_v1alpha2_VirtualMachineSetResourcePolicy(a.(*VirtualMachineSetResourcePolicy), b.(*v1alpha2.VirtualMachineSetResourcePolicy), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineSetResourcePolicy)(nil), (*VirtualMachineSetResourcePolicy)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineSetResourcePolicy_To_v1alpha1_VirtualMachineSetResourcePolicy(a.(*v1alpha2.VirtualMachineSetResourcePolicy), b.(*VirtualMachineSetResourcePolicy), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineSetResourcePolicyList)(nil), (*v1alpha2.VirtualMachineSetResourcePolicyList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineSetResourcePolicyList_To_v1alpha2_VirtualMachineSetResourcePolicyList(a.(*VirtualMachineSetResourcePolicyList), b.(*v1alpha2.VirtualMachineSetResourcePolicyList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineSetResourcePolicyList)(nil), (*VirtualMachineSetResourcePolicyList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineSetResourcePolicyList_To_v1alpha1_VirtualMachineSetResourcePolicyList(a.(*v1alpha2.VirtualMachineSetResourcePolicyList), b.(*VirtualMachineSetResourcePolicyList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineSetResourcePolicyStatus)(nil), (*v1alpha2.VirtualMachineSetResourcePolicyStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineSetResourcePolicyStatus_To_v1alpha2_VirtualMachineSetResourcePolicyStatus(a.(*VirtualMachineSetResourcePolicyStatus), b.(*v1alpha2.VirtualMachineSetResourcePolicyStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineSetResourcePolicyStatus)(nil), (*VirtualMachineSetResourcePolicyStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineSetResourcePolicyStatus_To_v1alpha1_VirtualMachineSetResourcePolicyStatus(a.(*v1alpha2.VirtualMachineSetResourcePolicyStatus), b.(*VirtualMachineSetResourcePolicyStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*VirtualMachineTemplate)(nil), (*v1alpha2.VirtualMachineTemplate)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineTemplate_To_v1alpha2_VirtualMachineTemplate(a.(*VirtualMachineTemplate), b.(*v1alpha2.VirtualMachineTemplate), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha2.VirtualMachineTemplate)(nil), (*VirtualMachineTemplate)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineTemplate_To_v1alpha1_VirtualMachineTemplate(a.(*v1alpha2.VirtualMachineTemplate), b.(*VirtualMachineTemplate), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*common.LocalObjectRef)(nil), (*ContentProviderReference)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_common_LocalObjectRef_To_v1alpha1_ContentProviderReference(a.(*common.LocalObjectRef), b.(*ContentProviderReference), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*v1.Condition)(nil), (*Condition)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1_Condition_To_v1alpha1_Condition(a.(*v1.Condition), b.(*Condition), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*Condition)(nil), (*v1.Condition)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_Condition_To_v1_Condition(a.(*Condition), b.(*v1.Condition), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*ContentProviderReference)(nil), (*common.LocalObjectRef)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_ContentProviderReference_To_common_LocalObjectRef(a.(*ContentProviderReference), b.(*common.LocalObjectRef), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*VirtualMachineImageSpec)(nil), (*v1alpha2.VirtualMachineImageSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineImageSpec_To_v1alpha2_VirtualMachineImageSpec(a.(*VirtualMachineImageSpec), b.(*v1alpha2.VirtualMachineImageSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*VirtualMachineImageStatus)(nil), (*v1alpha2.VirtualMachineImageStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineImageStatus_To_v1alpha2_VirtualMachineImageStatus(a.(*VirtualMachineImageStatus), b.(*v1alpha2.VirtualMachineImageStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*VirtualMachineSetResourcePolicySpec)(nil), (*v1alpha2.VirtualMachineSetResourcePolicySpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineSetResourcePolicySpec_To_v1alpha2_VirtualMachineSetResourcePolicySpec(a.(*VirtualMachineSetResourcePolicySpec), b.(*v1alpha2.VirtualMachineSetResourcePolicySpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*VirtualMachineSpec)(nil), (*v1alpha2.VirtualMachineSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineSpec_To_v1alpha2_VirtualMachineSpec(a.(*VirtualMachineSpec), b.(*v1alpha2.VirtualMachineSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*VirtualMachineStatus)(nil), (*v1alpha2.VirtualMachineStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineStatus_To_v1alpha2_VirtualMachineStatus(a.(*VirtualMachineStatus), b.(*v1alpha2.VirtualMachineStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*VirtualMachineVolumeProvisioningOptions)(nil), (*v1alpha2.VirtualMachineVolumeProvisioningOptions)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineVolumeProvisioningOptions_To_v1alpha2_VirtualMachineVolumeProvisioningOptions(a.(*VirtualMachineVolumeProvisioningOptions), b.(*v1alpha2.VirtualMachineVolumeProvisioningOptions), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*VirtualMachineVolumeStatus)(nil), (*v1alpha2.VirtualMachineVolumeStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineVolumeStatus_To_v1alpha2_VirtualMachineVolumeStatus(a.(*VirtualMachineVolumeStatus), b.(*v1alpha2.VirtualMachineVolumeStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*VirtualMachineVolume)(nil), (*v1alpha2.VirtualMachineVolume)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha1_VirtualMachineVolume_To_v1alpha2_VirtualMachineVolume(a.(*VirtualMachineVolume), b.(*v1alpha2.VirtualMachineVolume), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*v1alpha2.VirtualMachineClassStatus)(nil), (*VirtualMachineClassStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineClassStatus_To_v1alpha1_VirtualMachineClassStatus(a.(*v1alpha2.VirtualMachineClassStatus), b.(*VirtualMachineClassStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*v1alpha2.VirtualMachineImageOSInfo)(nil), (*VirtualMachineImageOSInfo)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineImageOSInfo_To_v1alpha1_VirtualMachineImageOSInfo(a.(*v1alpha2.VirtualMachineImageOSInfo), b.(*VirtualMachineImageOSInfo), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*v1alpha2.VirtualMachineImageStatus)(nil), (*VirtualMachineImageStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineImageStatus_To_v1alpha1_VirtualMachineImageStatus(a.(*v1alpha2.VirtualMachineImageStatus), b.(*VirtualMachineImageStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*v1alpha2.VirtualMachineSetResourcePolicySpec)(nil), (*VirtualMachineSetResourcePolicySpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineSetResourcePolicySpec_To_v1alpha1_VirtualMachineSetResourcePolicySpec(a.(*v1alpha2.VirtualMachineSetResourcePolicySpec), b.(*VirtualMachineSetResourcePolicySpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*v1alpha2.VirtualMachineSpec)(nil), (*VirtualMachineSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineSpec_To_v1alpha1_VirtualMachineSpec(a.(*v1alpha2.VirtualMachineSpec), b.(*VirtualMachineSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*v1alpha2.VirtualMachineStatus)(nil), (*VirtualMachineStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineStatus_To_v1alpha1_VirtualMachineStatus(a.(*v1alpha2.VirtualMachineStatus), b.(*VirtualMachineStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*v1alpha2.VirtualMachineVolumeProvisioningOptions)(nil), (*VirtualMachineVolumeProvisioningOptions)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineVolumeProvisioningOptions_To_v1alpha1_VirtualMachineVolumeProvisioningOptions(a.(*v1alpha2.VirtualMachineVolumeProvisioningOptions), b.(*VirtualMachineVolumeProvisioningOptions), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*v1alpha2.VirtualMachineVolumeStatus)(nil), (*VirtualMachineVolumeStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineVolumeStatus_To_v1alpha1_VirtualMachineVolumeStatus(a.(*v1alpha2.VirtualMachineVolumeStatus), b.(*VirtualMachineVolumeStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*v1alpha2.VirtualMachineVolume)(nil), (*VirtualMachineVolume)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha2_VirtualMachineVolume_To_v1alpha1_VirtualMachineVolume(a.(*v1alpha2.VirtualMachineVolume), b.(*VirtualMachineVolume), scope)
	}); err != nil {
		return err
	}
	return nil
}

func autoConvert_v1alpha1_ClusterVirtualMachineImage_To_v1alpha2_ClusterVirtualMachineImage(in *ClusterVirtualMachineImage, out *v1alpha2.ClusterVirtualMachineImage, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1alpha1_VirtualMachineImageSpec_To_v1alpha2_VirtualMachineImageSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_v1alpha1_VirtualMachineImageStatus_To_v1alpha2_VirtualMachineImageStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha1_ClusterVirtualMachineImage_To_v1alpha2_ClusterVirtualMachineImage is an autogenerated conversion function.
func Convert_v1alpha1_ClusterVirtualMachineImage_To_v1alpha2_ClusterVirtualMachineImage(in *ClusterVirtualMachineImage, out *v1alpha2.ClusterVirtualMachineImage, s conversion.Scope) error {
	return autoConvert_v1alpha1_ClusterVirtualMachineImage_To_v1alpha2_ClusterVirtualMachineImage(in, out, s)
}

func autoConvert_v1alpha2_ClusterVirtualMachineImage_To_v1alpha1_ClusterVirtualMachineImage(in *v1alpha2.ClusterVirtualMachineImage, out *ClusterVirtualMachineImage, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1alpha2_VirtualMachineImageSpec_To_v1alpha1_VirtualMachineImageSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_v1alpha2_VirtualMachineImageStatus_To_v1alpha1_VirtualMachineImageStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha2_ClusterVirtualMachineImage_To_v1alpha1_ClusterVirtualMachineImage is an autogenerated conversion function.
func Convert_v1alpha2_ClusterVirtualMachineImage_To_v1alpha1_ClusterVirtualMachineImage(in *v1alpha2.ClusterVirtualMachineImage, out *ClusterVirtualMachineImage, s conversion.Scope) error {
	return autoConvert_v1alpha2_ClusterVirtualMachineImage_To_v1alpha1_ClusterVirtualMachineImage(in, out, s)
}

func autoConvert_v1alpha1_ClusterVirtualMachineImageList_To_v1alpha2_ClusterVirtualMachineImageList(in *ClusterVirtualMachineImageList, out *v1alpha2.ClusterVirtualMachineImageList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]v1alpha2.ClusterVirtualMachineImage, len(*in))
		for i := range *in {
			if err := Convert_v1alpha1_ClusterVirtualMachineImage_To_v1alpha2_ClusterVirtualMachineImage(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Items = nil
	}
	return nil
}

// Convert_v1alpha1_ClusterVirtualMachineImageList_To_v1alpha2_ClusterVirtualMachineImageList is an autogenerated conversion function.
func Convert_v1alpha1_ClusterVirtualMachineImageList_To_v1alpha2_ClusterVirtualMachineImageList(in *ClusterVirtualMachineImageList, out *v1alpha2.ClusterVirtualMachineImageList, s conversion.Scope) error {
	return autoConvert_v1alpha1_ClusterVirtualMachineImageList_To_v1alpha2_ClusterVirtualMachineImageList(in, out, s)
}

func autoConvert_v1alpha2_ClusterVirtualMachineImageList_To_v1alpha1_ClusterVirtualMachineImageList(in *v1alpha2.ClusterVirtualMachineImageList, out *ClusterVirtualMachineImageList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]ClusterVirtualMachineImage, len(*in))
		for i := range *in {
			if err := Convert_v1alpha2_ClusterVirtualMachineImage_To_v1alpha1_ClusterVirtualMachineImage(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Items = nil
	}
	return nil
}

// Convert_v1alpha2_ClusterVirtualMachineImageList_To_v1alpha1_ClusterVirtualMachineImageList is an autogenerated conversion function.
func Convert_v1alpha2_ClusterVirtualMachineImageList_To_v1alpha1_ClusterVirtualMachineImageList(in *v1alpha2.ClusterVirtualMachineImageList, out *ClusterVirtualMachineImageList, s conversion.Scope) error {
	return autoConvert_v1alpha2_ClusterVirtualMachineImageList_To_v1alpha1_ClusterVirtualMachineImageList(in, out, s)
}

func autoConvert_v1alpha1_Condition_To_v1_Condition(in *Condition, out *v1.Condition, s conversion.Scope) error {
	out.Type = string(in.Type)
	out.Status = v1.ConditionStatus(in.Status)
	// WARNING: in.Severity requires manual conversion: does not exist in peer-type
	out.LastTransitionTime = in.LastTransitionTime
	out.Reason = in.Reason
	out.Message = in.Message
	return nil
}

func autoConvert_v1_Condition_To_v1alpha1_Condition(in *v1.Condition, out *Condition, s conversion.Scope) error {
	out.Type = ConditionType(in.Type)
	out.Status = corev1.ConditionStatus(in.Status)
	// WARNING: in.ObservedGeneration requires manual conversion: does not exist in peer-type
	out.LastTransitionTime = in.LastTransitionTime
	out.Reason = in.Reason
	out.Message = in.Message
	return nil
}

func autoConvert_v1alpha1_DynamicDirectPathIODevice_To_v1alpha2_DynamicDirectPathIODevice(in *DynamicDirectPathIODevice, out *v1alpha2.DynamicDirectPathIODevice, s conversion.Scope) error {
	out.VendorID = int64(in.VendorID)
	out.DeviceID = int64(in.DeviceID)
	out.CustomLabel = in.CustomLabel
	return nil
}

// Convert_v1alpha1_DynamicDirectPathIODevice_To_v1alpha2_DynamicDirectPathIODevice is an autogenerated conversion function.
func Convert_v1alpha1_DynamicDirectPathIODevice_To_v1alpha2_DynamicDirectPathIODevice(in *DynamicDirectPathIODevice, out *v1alpha2.DynamicDirectPathIODevice, s conversion.Scope) error {
	return autoConvert_v1alpha1_DynamicDirectPathIODevice_To_v1alpha2_DynamicDirectPathIODevice(in, out, s)
}

func autoConvert_v1alpha2_DynamicDirectPathIODevice_To_v1alpha1_DynamicDirectPathIODevice(in *v1alpha2.DynamicDirectPathIODevice, out *DynamicDirectPathIODevice, s conversion.Scope) error {
	out.VendorID = int(in.VendorID)
	out.DeviceID = int(in.DeviceID)
	out.CustomLabel = in.CustomLabel
	return nil
}

// Convert_v1alpha2_DynamicDirectPathIODevice_To_v1alpha1_DynamicDirectPathIODevice is an autogenerated conversion function.
func Convert_v1alpha2_DynamicDirectPathIODevice_To_v1alpha1_DynamicDirectPathIODevice(in *v1alpha2.DynamicDirectPathIODevice, out *DynamicDirectPathIODevice, s conversion.Scope) error {
	return autoConvert_v1alpha2_DynamicDirectPathIODevice_To_v1alpha1_DynamicDirectPathIODevice(in, out, s)
}

func autoConvert_v1alpha1_GuestHeartbeatAction_To_v1alpha2_GuestHeartbeatAction(in *GuestHeartbeatAction, out *v1alpha2.GuestHeartbeatAction, s conversion.Scope) error {
	out.ThresholdStatus = v1alpha2.GuestHeartbeatStatus(in.ThresholdStatus)
	return nil
}

// Convert_v1alpha1_GuestHeartbeatAction_To_v1alpha2_GuestHeartbeatAction is an autogenerated conversion function.
func Convert_v1alpha1_GuestHeartbeatAction_To_v1alpha2_GuestHeartbeatAction(in *GuestHeartbeatAction, out *v1alpha2.GuestHeartbeatAction, s conversion.Scope) error {
	return autoConvert_v1alpha1_GuestHeartbeatAction_To_v1alpha2_GuestHeartbeatAction(in, out, s)
}

func autoConvert_v1alpha2_GuestHeartbeatAction_To_v1alpha1_GuestHeartbeatAction(in *v1alpha2.GuestHeartbeatAction, out *GuestHeartbeatAction, s conversion.Scope) error {
	out.ThresholdStatus = GuestHeartbeatStatus(in.ThresholdStatus)
	return nil
}

// Convert_v1alpha2_GuestHeartbeatAction_To_v1alpha1_GuestHeartbeatAction is an autogenerated conversion function.
func Convert_v1alpha2_GuestHeartbeatAction_To_v1alpha1_GuestHeartbeatAction(in *v1alpha2.GuestHeartbeatAction, out *GuestHeartbeatAction, s conversion.Scope) error {
	return autoConvert_v1alpha2_GuestHeartbeatAction_To_v1alpha1_GuestHeartbeatAction(in, out, s)
}

func autoConvert_v1alpha1_InstanceStorage_To_v1alpha2_InstanceStorage(in *InstanceStorage, out *v1alpha2.InstanceStorage, s conversion.Scope) error {
	out.StorageClass = in.StorageClass
	out.Volumes = *(*[]v1alpha2.InstanceStorageVolume)(unsafe.Pointer(&in.Volumes))
	return nil
}

// Convert_v1alpha1_InstanceStorage_To_v1alpha2_InstanceStorage is an autogenerated conversion function.
func Convert_v1alpha1_InstanceStorage_To_v1alpha2_InstanceStorage(in *InstanceStorage, out *v1alpha2.InstanceStorage, s conversion.Scope) error {
	return autoConvert_v1alpha1_InstanceStorage_To_v1alpha2_InstanceStorage(in, out, s)
}

func autoConvert_v1alpha2_InstanceStorage_To_v1alpha1_InstanceStorage(in *v1alpha2.InstanceStorage, out *InstanceStorage, s conversion.Scope) error {
	out.StorageClass = in.StorageClass
	out.Volumes = *(*[]InstanceStorageVolume)(unsafe.Pointer(&in.Volumes))
	return nil
}

// Convert_v1alpha2_InstanceStorage_To_v1alpha1_InstanceStorage is an autogenerated conversion function.
func Convert_v1alpha2_InstanceStorage_To_v1alpha1_InstanceStorage(in *v1alpha2.InstanceStorage, out *InstanceStorage, s conversion.Scope) error {
	return autoConvert_v1alpha2_InstanceStorage_To_v1alpha1_InstanceStorage(in, out, s)
}

func autoConvert_v1alpha1_InstanceStorageVolume_To_v1alpha2_InstanceStorageVolume(in *InstanceStorageVolume, out *v1alpha2.InstanceStorageVolume, s conversion.Scope) error {
	out.Size = in.Size
	return nil
}

// Convert_v1alpha1_InstanceStorageVolume_To_v1alpha2_InstanceStorageVolume is an autogenerated conversion function.
func Convert_v1alpha1_InstanceStorageVolume_To_v1alpha2_InstanceStorageVolume(in *InstanceStorageVolume, out *v1alpha2.InstanceStorageVolume, s conversion.Scope) error {
	return autoConvert_v1alpha1_InstanceStorageVolume_To_v1alpha2_InstanceStorageVolume(in, out, s)
}

func autoConvert_v1alpha2_InstanceStorageVolume_To_v1alpha1_InstanceStorageVolume(in *v1alpha2.InstanceStorageVolume, out *InstanceStorageVolume, s conversion.Scope) error {
	out.Size = in.Size
	return nil
}

// Convert_v1alpha2_InstanceStorageVolume_To_v1alpha1_InstanceStorageVolume is an autogenerated conversion function.
func Convert_v1alpha2_InstanceStorageVolume_To_v1alpha1_InstanceStorageVolume(in *v1alpha2.InstanceStorageVolume, out *InstanceStorageVolume, s conversion.Scope) error {
	return autoConvert_v1alpha2_InstanceStorageVolume_To_v1alpha1_InstanceStorageVolume(in, out, s)
}

func autoConvert_v1alpha1_LoadBalancerIngress_To_v1alpha2_LoadBalancerIngress(in *LoadBalancerIngress, out *v1alpha2.LoadBalancerIngress, s conversion.Scope) error {
	out.IP = in.IP
	out.Hostname = in.Hostname
	return nil
}

// Convert_v1alpha1_LoadBalancerIngress_To_v1alpha2_LoadBalancerIngress is an autogenerated conversion function.
func Convert_v1alpha1_LoadBalancerIngress_To_v1alpha2_LoadBalancerIngress(in *LoadBalancerIngress, out *v1alpha2.LoadBalancerIngress, s conversion.Scope) error {
	return autoConvert_v1alpha1_LoadBalancerIngress_To_v1alpha2_LoadBalancerIngress(in, out, s)
}

func autoConvert_v1alpha2_LoadBalancerIngress_To_v1alpha1_LoadBalancerIngress(in *v1alpha2.LoadBalancerIngress, out *LoadBalancerIngress, s conversion.Scope) error {
	out.IP = in.IP
	out.Hostname = in.Hostname
	return nil
}

// Convert_v1alpha2_LoadBalancerIngress_To_v1alpha1_LoadBalancerIngress is an autogenerated conversion function.
func Convert_v1alpha2_LoadBalancerIngress_To_v1alpha1_LoadBalancerIngress(in *v1alpha2.LoadBalancerIngress, out *LoadBalancerIngress, s conversion.Scope) error {
	return autoConvert_v1alpha2_LoadBalancerIngress_To_v1alpha1_LoadBalancerIngress(in, out, s)
}

func autoConvert_v1alpha1_LoadBalancerStatus_To_v1alpha2_LoadBalancerStatus(in *LoadBalancerStatus, out *v1alpha2.LoadBalancerStatus, s conversion.Scope) error {
	out.Ingress = *(*[]v1alpha2.LoadBalancerIngress)(unsafe.Pointer(&in.Ingress))
	return nil
}

// Convert_v1alpha1_LoadBalancerStatus_To_v1alpha2_LoadBalancerStatus is an autogenerated conversion function.
func Convert_v1alpha1_LoadBalancerStatus_To_v1alpha2_LoadBalancerStatus(in *LoadBalancerStatus, out *v1alpha2.LoadBalancerStatus, s conversion.Scope) error {
	return autoConvert_v1alpha1_LoadBalancerStatus_To_v1alpha2_LoadBalancerStatus(in, out, s)
}

func autoConvert_v1alpha2_LoadBalancerStatus_To_v1alpha1_LoadBalancerStatus(in *v1alpha2.LoadBalancerStatus, out *LoadBalancerStatus, s conversion.Scope) error {
	out.Ingress = *(*[]LoadBalancerIngress)(unsafe.Pointer(&in.Ingress))
	return nil
}

// Convert_v1alpha2_LoadBalancerStatus_To_v1alpha1_LoadBalancerStatus is an autogenerated conversion function.
func Convert_v1alpha2_LoadBalancerStatus_To_v1alpha1_LoadBalancerStatus(in *v1alpha2.LoadBalancerStatus, out *LoadBalancerStatus, s conversion.Scope) error {
	return autoConvert_v1alpha2_LoadBalancerStatus_To_v1alpha1_LoadBalancerStatus(in, out, s)
}

func autoConvert_v1alpha1_NetworkDeviceStatus_To_v1alpha2_NetworkDeviceStatus(in *NetworkDeviceStatus, out *v1alpha2.NetworkDeviceStatus, s conversion.Scope) error {
	out.Gateway4 = in.Gateway4
	out.IPAddresses = *(*[]string)(unsafe.Pointer(&in.IPAddresses))
	return nil
}

// Convert_v1alpha1_NetworkDeviceStatus_To_v1alpha2_NetworkDeviceStatus is an autogenerated conversion function.
func Convert_v1alpha1_NetworkDeviceStatus_To_v1alpha2_NetworkDeviceStatus(in *NetworkDeviceStatus, out *v1alpha2.NetworkDeviceStatus, s conversion.Scope) error {
	return autoConvert_v1alpha1_NetworkDeviceStatus_To_v1alpha2_NetworkDeviceStatus(in, out, s)
}

func autoConvert_v1alpha2_NetworkDeviceStatus_To_v1alpha1_NetworkDeviceStatus(in *v1alpha2.NetworkDeviceStatus, out *NetworkDeviceStatus, s conversion.Scope) error {
	out.Gateway4 = in.Gateway4
	out.IPAddresses = *(*[]string)(unsafe.Pointer(&in.IPAddresses))
	return nil
}

// Convert_v1alpha2_NetworkDeviceStatus_To_v1alpha1_NetworkDeviceStatus is an autogenerated conversion function.
func Convert_v1alpha2_NetworkDeviceStatus_To_v1alpha1_NetworkDeviceStatus(in *v1alpha2.NetworkDeviceStatus, out *NetworkDeviceStatus, s conversion.Scope) error {
	return autoConvert_v1alpha2_NetworkDeviceStatus_To_v1alpha1_NetworkDeviceStatus(in, out, s)
}

func autoConvert_v1alpha1_NetworkStatus_To_v1alpha2_NetworkStatus(in *NetworkStatus, out *v1alpha2.NetworkStatus, s conversion.Scope) error {
	out.Devices = *(*[]v1alpha2.NetworkDeviceStatus)(unsafe.Pointer(&in.Devices))
	out.Nameservers = *(*[]string)(unsafe.Pointer(&in.Nameservers))
	return nil
}

// Convert_v1alpha1_NetworkStatus_To_v1alpha2_NetworkStatus is an autogenerated conversion function.
func Convert_v1alpha1_NetworkStatus_To_v1alpha2_NetworkStatus(in *NetworkStatus, out *v1alpha2.NetworkStatus, s conversion.Scope) error {
	return autoConvert_v1alpha1_NetworkStatus_To_v1alpha2_NetworkStatus(in, out, s)
}

func autoConvert_v1alpha2_NetworkStatus_To_v1alpha1_NetworkStatus(in *v1alpha2.NetworkStatus, out *NetworkStatus, s conversion.Scope) error {
	out.Devices = *(*[]NetworkDeviceStatus)(unsafe.Pointer(&in.Devices))
	out.Nameservers = *(*[]string)(unsafe.Pointer(&in.Nameservers))
	return nil
}

// Convert_v1alpha2_NetworkStatus_To_v1alpha1_NetworkStatus is an autogenerated conversion function.
func Convert_v1alpha2_NetworkStatus_To_v1alpha1_NetworkStatus(in *v1alpha2.NetworkStatus, out *NetworkStatus, s conversion.Scope) error {
	return autoConvert_v1alpha2_NetworkStatus_To_v1alpha1_NetworkStatus(in, out, s)
}

func autoConvert_v1alpha1_ResourcePoolSpec_To_v1alpha2_ResourcePoolSpec(in *ResourcePoolSpec, out *v1alpha2.ResourcePoolSpec, s conversion.Scope) error {
	out.Name = in.Name
	if err := Convert_v1alpha1_VirtualMachineResourceSpec_To_v1alpha2_VirtualMachineResourceSpec(&in.Reservations, &out.Reservations, s); err != nil {
		return err
	}
	if err := Convert_v1alpha1_VirtualMachineResourceSpec_To_v1alpha2_VirtualMachineResourceSpec(&in.Limits, &out.Limits, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha1_ResourcePoolSpec_To_v1alpha2_ResourcePoolSpec is an autogenerated conversion function.
func Convert_v1alpha1_ResourcePoolSpec_To_v1alpha2_ResourcePoolSpec(in *ResourcePoolSpec, out *v1alpha2.ResourcePoolSpec, s conversion.Scope) error {
	return autoConvert_v1alpha1_ResourcePoolSpec_To_v1alpha2_ResourcePoolSpec(in, out, s)
}

func autoConvert_v1alpha2_ResourcePoolSpec_To_v1alpha1_ResourcePoolSpec(in *v1alpha2.ResourcePoolSpec, out *ResourcePoolSpec, s conversion.Scope) error {
	out.Name = in.Name
	if err := Convert_v1alpha2_VirtualMachineResourceSpec_To_v1alpha1_VirtualMachineResourceSpec(&in.Reservations, &out.Reservations, s); err != nil {
		return err
	}
	if err := Convert_v1alpha2_VirtualMachineResourceSpec_To_v1alpha1_VirtualMachineResourceSpec(&in.Limits, &out.Limits, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha2_ResourcePoolSpec_To_v1alpha1_ResourcePoolSpec is an autogenerated conversion function.
func Convert_v1alpha2_ResourcePoolSpec_To_v1alpha1_ResourcePoolSpec(in *v1alpha2.ResourcePoolSpec, out *ResourcePoolSpec, s conversion.Scope) error {
	return autoConvert_v1alpha2_ResourcePoolSpec_To_v1alpha1_ResourcePoolSpec(in, out, s)
}

func autoConvert_v1alpha1_TCPSocketAction_To_v1alpha2_TCPSocketAction(in *TCPSocketAction, out *v1alpha2.TCPSocketAction, s conversion.Scope) error {
	out.Port = in.Port
	out.Host = in.Host
	return nil
}

// Convert_v1alpha1_TCPSocketAction_To_v1alpha2_TCPSocketAction is an autogenerated conversion function.
func Convert_v1alpha1_TCPSocketAction_To_v1alpha2_TCPSocketAction(in *TCPSocketAction, out *v1alpha2.TCPSocketAction, s conversion.Scope) error {
	return autoConvert_v1alpha1_TCPSocketAction_To_v1alpha2_TCPSocketAction(in, out, s)
}

func autoConvert_v1alpha2_TCPSocketAction_To_v1alpha1_TCPSocketAction(in *v1alpha2.TCPSocketAction, out *TCPSocketAction, s conversion.Scope) error {
	out.Port = in.Port
	out.Host = in.Host
	return nil
}

// Convert_v1alpha2_TCPSocketAction_To_v1alpha1_TCPSocketAction is an autogenerated conversion function.
func Convert_v1alpha2_TCPSocketAction_To_v1alpha1_TCPSocketAction(in *v1alpha2.TCPSocketAction, out *TCPSocketAction, s conversion.Scope) error {
	return autoConvert_v1alpha2_TCPSocketAction_To_v1alpha1_TCPSocketAction(in, out, s)
}

func autoConvert_v1alpha1_VGPUDevice_To_v1alpha2_VGPUDevice(in *VGPUDevice, out *v1alpha2.VGPUDevice, s conversion.Scope) error {
	out.ProfileName = in.ProfileName
	return nil
}

// Convert_v1alpha1_VGPUDevice_To_v1alpha2_VGPUDevice is an autogenerated conversion function.
func Convert_v1alpha1_VGPUDevice_To_v1alpha2_VGPUDevice(in *VGPUDevice, out *v1alpha2.VGPUDevice, s conversion.Scope) error {
	return autoConvert_v1alpha1_VGPUDevice_To_v1alpha2_VGPUDevice(in, out, s)
}

func autoConvert_v1alpha2_VGPUDevice_To_v1alpha1_VGPUDevice(in *v1alpha2.VGPUDevice, out *VGPUDevice, s conversion.Scope) error {
	out.ProfileName = in.ProfileName
	return nil
}

// Convert_v1alpha2_VGPUDevice_To_v1alpha1_VGPUDevice is an autogenerated conversion function.
func Convert_v1alpha2_VGPUDevice_To_v1alpha1_VGPUDevice(in *v1alpha2.VGPUDevice, out *VGPUDevice, s conversion.Scope) error {
	return autoConvert_v1alpha2_VGPUDevice_To_v1alpha1_VGPUDevice(in, out, s)
}

func autoConvert_v1alpha1_VirtualDevices_To_v1alpha2_VirtualDevices(in *VirtualDevices, out *v1alpha2.VirtualDevices, s conversion.Scope) error {
	out.VGPUDevices = *(*[]v1alpha2.VGPUDevice)(unsafe.Pointer(&in.VGPUDevices))
	if in.DynamicDirectPathIODevices != nil {
		in, out := &in.DynamicDirectPathIODevices, &out.DynamicDirectPathIODevices
		*out = make([]v1alpha2.DynamicDirectPathIODevice, len(*in))
		for i := range *in {
			if err := Convert_v1alpha1_DynamicDirectPathIODevice_To_v1alpha2_DynamicDirectPathIODevice(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.DynamicDirectPathIODevices = nil
	}
	return nil
}

// Convert_v1alpha1_VirtualDevices_To_v1alpha2_VirtualDevices is an autogenerated conversion function.
func Convert_v1alpha1_VirtualDevices_To_v1alpha2_VirtualDevices(in *VirtualDevices, out *v1alpha2.VirtualDevices, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualDevices_To_v1alpha2_VirtualDevices(in, out, s)
}

func autoConvert_v1alpha2_VirtualDevices_To_v1alpha1_VirtualDevices(in *v1alpha2.VirtualDevices, out *VirtualDevices, s conversion.Scope) error {
	out.VGPUDevices = *(*[]VGPUDevice)(unsafe.Pointer(&in.VGPUDevices))
	if in.DynamicDirectPathIODevices != nil {
		in, out := &in.DynamicDirectPathIODevices, &out.DynamicDirectPathIODevices
		*out = make([]DynamicDirectPathIODevice, len(*in))
		for i := range *in {
			if err := Convert_v1alpha2_DynamicDirectPathIODevice_To_v1alpha1_DynamicDirectPathIODevice(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.DynamicDirectPathIODevices = nil
	}
	return nil
}

// Convert_v1alpha2_VirtualDevices_To_v1alpha1_VirtualDevices is an autogenerated conversion function.
func Convert_v1alpha2_VirtualDevices_To_v1alpha1_VirtualDevices(in *v1alpha2.VirtualDevices, out *VirtualDevices, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualDevices_To_v1alpha1_VirtualDevices(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachine_To_v1alpha2_VirtualMachine(in *VirtualMachine, out *v1alpha2.VirtualMachine, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1alpha1_VirtualMachineSpec_To_v1alpha2_VirtualMachineSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_v1alpha1_VirtualMachineStatus_To_v1alpha2_VirtualMachineStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha1_VirtualMachine_To_v1alpha2_VirtualMachine is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachine_To_v1alpha2_VirtualMachine(in *VirtualMachine, out *v1alpha2.VirtualMachine, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachine_To_v1alpha2_VirtualMachine(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachine_To_v1alpha1_VirtualMachine(in *v1alpha2.VirtualMachine, out *VirtualMachine, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1alpha2_VirtualMachineSpec_To_v1alpha1_VirtualMachineSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_v1alpha2_VirtualMachineStatus_To_v1alpha1_VirtualMachineStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha2_VirtualMachine_To_v1alpha1_VirtualMachine is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachine_To_v1alpha1_VirtualMachine(in *v1alpha2.VirtualMachine, out *VirtualMachine, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachine_To_v1alpha1_VirtualMachine(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineClass_To_v1alpha2_VirtualMachineClass(in *VirtualMachineClass, out *v1alpha2.VirtualMachineClass, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1alpha1_VirtualMachineClassSpec_To_v1alpha2_VirtualMachineClassSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_v1alpha1_VirtualMachineClassStatus_To_v1alpha2_VirtualMachineClassStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha1_VirtualMachineClass_To_v1alpha2_VirtualMachineClass is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineClass_To_v1alpha2_VirtualMachineClass(in *VirtualMachineClass, out *v1alpha2.VirtualMachineClass, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineClass_To_v1alpha2_VirtualMachineClass(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineClass_To_v1alpha1_VirtualMachineClass(in *v1alpha2.VirtualMachineClass, out *VirtualMachineClass, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1alpha2_VirtualMachineClassSpec_To_v1alpha1_VirtualMachineClassSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_v1alpha2_VirtualMachineClassStatus_To_v1alpha1_VirtualMachineClassStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha2_VirtualMachineClass_To_v1alpha1_VirtualMachineClass is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineClass_To_v1alpha1_VirtualMachineClass(in *v1alpha2.VirtualMachineClass, out *VirtualMachineClass, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineClass_To_v1alpha1_VirtualMachineClass(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineClassHardware_To_v1alpha2_VirtualMachineClassHardware(in *VirtualMachineClassHardware, out *v1alpha2.VirtualMachineClassHardware, s conversion.Scope) error {
	out.Cpus = in.Cpus
	out.Memory = in.Memory
	if err := Convert_v1alpha1_VirtualDevices_To_v1alpha2_VirtualDevices(&in.Devices, &out.Devices, s); err != nil {
		return err
	}
	if err := Convert_v1alpha1_InstanceStorage_To_v1alpha2_InstanceStorage(&in.InstanceStorage, &out.InstanceStorage, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha1_VirtualMachineClassHardware_To_v1alpha2_VirtualMachineClassHardware is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineClassHardware_To_v1alpha2_VirtualMachineClassHardware(in *VirtualMachineClassHardware, out *v1alpha2.VirtualMachineClassHardware, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineClassHardware_To_v1alpha2_VirtualMachineClassHardware(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineClassHardware_To_v1alpha1_VirtualMachineClassHardware(in *v1alpha2.VirtualMachineClassHardware, out *VirtualMachineClassHardware, s conversion.Scope) error {
	out.Cpus = in.Cpus
	out.Memory = in.Memory
	if err := Convert_v1alpha2_VirtualDevices_To_v1alpha1_VirtualDevices(&in.Devices, &out.Devices, s); err != nil {
		return err
	}
	if err := Convert_v1alpha2_InstanceStorage_To_v1alpha1_InstanceStorage(&in.InstanceStorage, &out.InstanceStorage, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha2_VirtualMachineClassHardware_To_v1alpha1_VirtualMachineClassHardware is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineClassHardware_To_v1alpha1_VirtualMachineClassHardware(in *v1alpha2.VirtualMachineClassHardware, out *VirtualMachineClassHardware, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineClassHardware_To_v1alpha1_VirtualMachineClassHardware(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineClassList_To_v1alpha2_VirtualMachineClassList(in *VirtualMachineClassList, out *v1alpha2.VirtualMachineClassList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]v1alpha2.VirtualMachineClass, len(*in))
		for i := range *in {
			if err := Convert_v1alpha1_VirtualMachineClass_To_v1alpha2_VirtualMachineClass(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Items = nil
	}
	return nil
}

// Convert_v1alpha1_VirtualMachineClassList_To_v1alpha2_VirtualMachineClassList is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineClassList_To_v1alpha2_VirtualMachineClassList(in *VirtualMachineClassList, out *v1alpha2.VirtualMachineClassList, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineClassList_To_v1alpha2_VirtualMachineClassList(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineClassList_To_v1alpha1_VirtualMachineClassList(in *v1alpha2.VirtualMachineClassList, out *VirtualMachineClassList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]VirtualMachineClass, len(*in))
		for i := range *in {
			if err := Convert_v1alpha2_VirtualMachineClass_To_v1alpha1_VirtualMachineClass(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Items = nil
	}
	return nil
}

// Convert_v1alpha2_VirtualMachineClassList_To_v1alpha1_VirtualMachineClassList is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineClassList_To_v1alpha1_VirtualMachineClassList(in *v1alpha2.VirtualMachineClassList, out *VirtualMachineClassList, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineClassList_To_v1alpha1_VirtualMachineClassList(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineClassPolicies_To_v1alpha2_VirtualMachineClassPolicies(in *VirtualMachineClassPolicies, out *v1alpha2.VirtualMachineClassPolicies, s conversion.Scope) error {
	if err := Convert_v1alpha1_VirtualMachineClassResources_To_v1alpha2_VirtualMachineClassResources(&in.Resources, &out.Resources, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha1_VirtualMachineClassPolicies_To_v1alpha2_VirtualMachineClassPolicies is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineClassPolicies_To_v1alpha2_VirtualMachineClassPolicies(in *VirtualMachineClassPolicies, out *v1alpha2.VirtualMachineClassPolicies, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineClassPolicies_To_v1alpha2_VirtualMachineClassPolicies(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineClassPolicies_To_v1alpha1_VirtualMachineClassPolicies(in *v1alpha2.VirtualMachineClassPolicies, out *VirtualMachineClassPolicies, s conversion.Scope) error {
	if err := Convert_v1alpha2_VirtualMachineClassResources_To_v1alpha1_VirtualMachineClassResources(&in.Resources, &out.Resources, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha2_VirtualMachineClassPolicies_To_v1alpha1_VirtualMachineClassPolicies is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineClassPolicies_To_v1alpha1_VirtualMachineClassPolicies(in *v1alpha2.VirtualMachineClassPolicies, out *VirtualMachineClassPolicies, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineClassPolicies_To_v1alpha1_VirtualMachineClassPolicies(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineClassResources_To_v1alpha2_VirtualMachineClassResources(in *VirtualMachineClassResources, out *v1alpha2.VirtualMachineClassResources, s conversion.Scope) error {
	if err := Convert_v1alpha1_VirtualMachineResourceSpec_To_v1alpha2_VirtualMachineResourceSpec(&in.Requests, &out.Requests, s); err != nil {
		return err
	}
	if err := Convert_v1alpha1_VirtualMachineResourceSpec_To_v1alpha2_VirtualMachineResourceSpec(&in.Limits, &out.Limits, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha1_VirtualMachineClassResources_To_v1alpha2_VirtualMachineClassResources is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineClassResources_To_v1alpha2_VirtualMachineClassResources(in *VirtualMachineClassResources, out *v1alpha2.VirtualMachineClassResources, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineClassResources_To_v1alpha2_VirtualMachineClassResources(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineClassResources_To_v1alpha1_VirtualMachineClassResources(in *v1alpha2.VirtualMachineClassResources, out *VirtualMachineClassResources, s conversion.Scope) error {
	if err := Convert_v1alpha2_VirtualMachineResourceSpec_To_v1alpha1_VirtualMachineResourceSpec(&in.Requests, &out.Requests, s); err != nil {
		return err
	}
	if err := Convert_v1alpha2_VirtualMachineResourceSpec_To_v1alpha1_VirtualMachineResourceSpec(&in.Limits, &out.Limits, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha2_VirtualMachineClassResources_To_v1alpha1_VirtualMachineClassResources is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineClassResources_To_v1alpha1_VirtualMachineClassResources(in *v1alpha2.VirtualMachineClassResources, out *VirtualMachineClassResources, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineClassResources_To_v1alpha1_VirtualMachineClassResources(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineClassSpec_To_v1alpha2_VirtualMachineClassSpec(in *VirtualMachineClassSpec, out *v1alpha2.VirtualMachineClassSpec, s conversion.Scope) error {
	if err := Convert_v1alpha1_VirtualMachineClassHardware_To_v1alpha2_VirtualMachineClassHardware(&in.Hardware, &out.Hardware, s); err != nil {
		return err
	}
	if err := Convert_v1alpha1_VirtualMachineClassPolicies_To_v1alpha2_VirtualMachineClassPolicies(&in.Policies, &out.Policies, s); err != nil {
		return err
	}
	out.Description = in.Description
	out.ConfigSpec = *(*json.RawMessage)(unsafe.Pointer(&in.ConfigSpec))
	return nil
}

// Convert_v1alpha1_VirtualMachineClassSpec_To_v1alpha2_VirtualMachineClassSpec is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineClassSpec_To_v1alpha2_VirtualMachineClassSpec(in *VirtualMachineClassSpec, out *v1alpha2.VirtualMachineClassSpec, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineClassSpec_To_v1alpha2_VirtualMachineClassSpec(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineClassSpec_To_v1alpha1_VirtualMachineClassSpec(in *v1alpha2.VirtualMachineClassSpec, out *VirtualMachineClassSpec, s conversion.Scope) error {
	if err := Convert_v1alpha2_VirtualMachineClassHardware_To_v1alpha1_VirtualMachineClassHardware(&in.Hardware, &out.Hardware, s); err != nil {
		return err
	}
	if err := Convert_v1alpha2_VirtualMachineClassPolicies_To_v1alpha1_VirtualMachineClassPolicies(&in.Policies, &out.Policies, s); err != nil {
		return err
	}
	out.Description = in.Description
	out.ConfigSpec = *(*json.RawMessage)(unsafe.Pointer(&in.ConfigSpec))
	return nil
}

// Convert_v1alpha2_VirtualMachineClassSpec_To_v1alpha1_VirtualMachineClassSpec is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineClassSpec_To_v1alpha1_VirtualMachineClassSpec(in *v1alpha2.VirtualMachineClassSpec, out *VirtualMachineClassSpec, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineClassSpec_To_v1alpha1_VirtualMachineClassSpec(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineClassStatus_To_v1alpha2_VirtualMachineClassStatus(in *VirtualMachineClassStatus, out *v1alpha2.VirtualMachineClassStatus, s conversion.Scope) error {
	return nil
}

// Convert_v1alpha1_VirtualMachineClassStatus_To_v1alpha2_VirtualMachineClassStatus is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineClassStatus_To_v1alpha2_VirtualMachineClassStatus(in *VirtualMachineClassStatus, out *v1alpha2.VirtualMachineClassStatus, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineClassStatus_To_v1alpha2_VirtualMachineClassStatus(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineClassStatus_To_v1alpha1_VirtualMachineClassStatus(in *v1alpha2.VirtualMachineClassStatus, out *VirtualMachineClassStatus, s conversion.Scope) error {
	// WARNING: in.Capabilities requires manual conversion: does not exist in peer-type
	// WARNING: in.Conditions requires manual conversion: does not exist in peer-type
	// WARNING: in.Ready requires manual conversion: does not exist in peer-type
	return nil
}

func autoConvert_v1alpha1_VirtualMachineImage_To_v1alpha2_VirtualMachineImage(in *VirtualMachineImage, out *v1alpha2.VirtualMachineImage, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1alpha1_VirtualMachineImageSpec_To_v1alpha2_VirtualMachineImageSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_v1alpha1_VirtualMachineImageStatus_To_v1alpha2_VirtualMachineImageStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha1_VirtualMachineImage_To_v1alpha2_VirtualMachineImage is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineImage_To_v1alpha2_VirtualMachineImage(in *VirtualMachineImage, out *v1alpha2.VirtualMachineImage, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineImage_To_v1alpha2_VirtualMachineImage(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineImage_To_v1alpha1_VirtualMachineImage(in *v1alpha2.VirtualMachineImage, out *VirtualMachineImage, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1alpha2_VirtualMachineImageSpec_To_v1alpha1_VirtualMachineImageSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_v1alpha2_VirtualMachineImageStatus_To_v1alpha1_VirtualMachineImageStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha2_VirtualMachineImage_To_v1alpha1_VirtualMachineImage is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineImage_To_v1alpha1_VirtualMachineImage(in *v1alpha2.VirtualMachineImage, out *VirtualMachineImage, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineImage_To_v1alpha1_VirtualMachineImage(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineImageList_To_v1alpha2_VirtualMachineImageList(in *VirtualMachineImageList, out *v1alpha2.VirtualMachineImageList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]v1alpha2.VirtualMachineImage, len(*in))
		for i := range *in {
			if err := Convert_v1alpha1_VirtualMachineImage_To_v1alpha2_VirtualMachineImage(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Items = nil
	}
	return nil
}

// Convert_v1alpha1_VirtualMachineImageList_To_v1alpha2_VirtualMachineImageList is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineImageList_To_v1alpha2_VirtualMachineImageList(in *VirtualMachineImageList, out *v1alpha2.VirtualMachineImageList, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineImageList_To_v1alpha2_VirtualMachineImageList(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineImageList_To_v1alpha1_VirtualMachineImageList(in *v1alpha2.VirtualMachineImageList, out *VirtualMachineImageList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]VirtualMachineImage, len(*in))
		for i := range *in {
			if err := Convert_v1alpha2_VirtualMachineImage_To_v1alpha1_VirtualMachineImage(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Items = nil
	}
	return nil
}

// Convert_v1alpha2_VirtualMachineImageList_To_v1alpha1_VirtualMachineImageList is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineImageList_To_v1alpha1_VirtualMachineImageList(in *v1alpha2.VirtualMachineImageList, out *VirtualMachineImageList, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineImageList_To_v1alpha1_VirtualMachineImageList(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineImageOSInfo_To_v1alpha2_VirtualMachineImageOSInfo(in *VirtualMachineImageOSInfo, out *v1alpha2.VirtualMachineImageOSInfo, s conversion.Scope) error {
	out.Version = in.Version
	out.Type = in.Type
	return nil
}

// Convert_v1alpha1_VirtualMachineImageOSInfo_To_v1alpha2_VirtualMachineImageOSInfo is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineImageOSInfo_To_v1alpha2_VirtualMachineImageOSInfo(in *VirtualMachineImageOSInfo, out *v1alpha2.VirtualMachineImageOSInfo, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineImageOSInfo_To_v1alpha2_VirtualMachineImageOSInfo(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineImageOSInfo_To_v1alpha1_VirtualMachineImageOSInfo(in *v1alpha2.VirtualMachineImageOSInfo, out *VirtualMachineImageOSInfo, s conversion.Scope) error {
	// WARNING: in.ID requires manual conversion: does not exist in peer-type
	out.Type = in.Type
	out.Version = in.Version
	return nil
}

func autoConvert_v1alpha1_VirtualMachineImageProductInfo_To_v1alpha2_VirtualMachineImageProductInfo(in *VirtualMachineImageProductInfo, out *v1alpha2.VirtualMachineImageProductInfo, s conversion.Scope) error {
	out.Product = in.Product
	out.Vendor = in.Vendor
	out.Version = in.Version
	out.FullVersion = in.FullVersion
	return nil
}

// Convert_v1alpha1_VirtualMachineImageProductInfo_To_v1alpha2_VirtualMachineImageProductInfo is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineImageProductInfo_To_v1alpha2_VirtualMachineImageProductInfo(in *VirtualMachineImageProductInfo, out *v1alpha2.VirtualMachineImageProductInfo, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineImageProductInfo_To_v1alpha2_VirtualMachineImageProductInfo(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineImageProductInfo_To_v1alpha1_VirtualMachineImageProductInfo(in *v1alpha2.VirtualMachineImageProductInfo, out *VirtualMachineImageProductInfo, s conversion.Scope) error {
	out.Product = in.Product
	out.Vendor = in.Vendor
	out.Version = in.Version
	out.FullVersion = in.FullVersion
	return nil
}

// Convert_v1alpha2_VirtualMachineImageProductInfo_To_v1alpha1_VirtualMachineImageProductInfo is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineImageProductInfo_To_v1alpha1_VirtualMachineImageProductInfo(in *v1alpha2.VirtualMachineImageProductInfo, out *VirtualMachineImageProductInfo, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineImageProductInfo_To_v1alpha1_VirtualMachineImageProductInfo(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineImageSpec_To_v1alpha2_VirtualMachineImageSpec(in *VirtualMachineImageSpec, out *v1alpha2.VirtualMachineImageSpec, s conversion.Scope) error {
	// WARNING: in.Type requires manual conversion: does not exist in peer-type
	// WARNING: in.ImageSourceType requires manual conversion: does not exist in peer-type
	// WARNING: in.ImageID requires manual conversion: does not exist in peer-type
	if err := Convert_v1alpha1_ContentProviderReference_To_common_LocalObjectRef(&in.ProviderRef, &out.ProviderRef, s); err != nil {
		return err
	}
	// WARNING: in.ProductInfo requires manual conversion: does not exist in peer-type
	// WARNING: in.OSInfo requires manual conversion: does not exist in peer-type
	// WARNING: in.OVFEnv requires manual conversion: does not exist in peer-type
	// WARNING: in.HardwareVersion requires manual conversion: does not exist in peer-type
	return nil
}

func autoConvert_v1alpha2_VirtualMachineImageSpec_To_v1alpha1_VirtualMachineImageSpec(in *v1alpha2.VirtualMachineImageSpec, out *VirtualMachineImageSpec, s conversion.Scope) error {
	if err := Convert_common_LocalObjectRef_To_v1alpha1_ContentProviderReference(&in.ProviderRef, &out.ProviderRef, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha2_VirtualMachineImageSpec_To_v1alpha1_VirtualMachineImageSpec is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineImageSpec_To_v1alpha1_VirtualMachineImageSpec(in *v1alpha2.VirtualMachineImageSpec, out *VirtualMachineImageSpec, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineImageSpec_To_v1alpha1_VirtualMachineImageSpec(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineImageStatus_To_v1alpha2_VirtualMachineImageStatus(in *VirtualMachineImageStatus, out *v1alpha2.VirtualMachineImageStatus, s conversion.Scope) error {
	// WARNING: in.Uuid requires manual conversion: does not exist in peer-type
	// WARNING: in.InternalId requires manual conversion: does not exist in peer-type
	// WARNING: in.PowerState requires manual conversion: does not exist in peer-type
	// WARNING: in.ImageName requires manual conversion: does not exist in peer-type
	// WARNING: in.ImageSupported requires manual conversion: does not exist in peer-type
	if in.Conditions != nil {
		in, out := &in.Conditions, &out.Conditions
		*out = make([]v1.Condition, len(*in))
		for i := range *in {
			if err := Convert_v1alpha1_Condition_To_v1_Condition(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Conditions = nil
	}
	// WARNING: in.ContentLibraryRef requires manual conversion: does not exist in peer-type
	// WARNING: in.ContentVersion requires manual conversion: does not exist in peer-type
	out.Firmware = in.Firmware
	return nil
}

func autoConvert_v1alpha2_VirtualMachineImageStatus_To_v1alpha1_VirtualMachineImageStatus(in *v1alpha2.VirtualMachineImageStatus, out *VirtualMachineImageStatus, s conversion.Scope) error {
	// WARNING: in.Name requires manual conversion: does not exist in peer-type
	// WARNING: in.Capabilities requires manual conversion: does not exist in peer-type
	out.Firmware = in.Firmware
	// WARNING: in.HardwareVersion requires manual conversion: does not exist in peer-type
	// WARNING: in.OSInfo requires manual conversion: does not exist in peer-type
	// WARNING: in.OVFProperties requires manual conversion: does not exist in peer-type
	// WARNING: in.ProductInfo requires manual conversion: does not exist in peer-type
	// WARNING: in.ProviderContentVersion requires manual conversion: does not exist in peer-type
	if in.Conditions != nil {
		in, out := &in.Conditions, &out.Conditions
		*out = make([]Condition, len(*in))
		for i := range *in {
			if err := Convert_v1_Condition_To_v1alpha1_Condition(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Conditions = nil
	}
	return nil
}

func autoConvert_v1alpha1_VirtualMachineList_To_v1alpha2_VirtualMachineList(in *VirtualMachineList, out *v1alpha2.VirtualMachineList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]v1alpha2.VirtualMachine, len(*in))
		for i := range *in {
			if err := Convert_v1alpha1_VirtualMachine_To_v1alpha2_VirtualMachine(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Items = nil
	}
	return nil
}

// Convert_v1alpha1_VirtualMachineList_To_v1alpha2_VirtualMachineList is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineList_To_v1alpha2_VirtualMachineList(in *VirtualMachineList, out *v1alpha2.VirtualMachineList, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineList_To_v1alpha2_VirtualMachineList(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineList_To_v1alpha1_VirtualMachineList(in *v1alpha2.VirtualMachineList, out *VirtualMachineList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]VirtualMachine, len(*in))
		for i := range *in {
			if err := Convert_v1alpha2_VirtualMachine_To_v1alpha1_VirtualMachine(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Items = nil
	}
	return nil
}

// Convert_v1alpha2_VirtualMachineList_To_v1alpha1_VirtualMachineList is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineList_To_v1alpha1_VirtualMachineList(in *v1alpha2.VirtualMachineList, out *VirtualMachineList, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineList_To_v1alpha1_VirtualMachineList(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachinePublishRequest_To_v1alpha2_VirtualMachinePublishRequest(in *VirtualMachinePublishRequest, out *v1alpha2.VirtualMachinePublishRequest, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1alpha1_VirtualMachinePublishRequestSpec_To_v1alpha2_VirtualMachinePublishRequestSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_v1alpha1_VirtualMachinePublishRequestStatus_To_v1alpha2_VirtualMachinePublishRequestStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha1_VirtualMachinePublishRequest_To_v1alpha2_VirtualMachinePublishRequest is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachinePublishRequest_To_v1alpha2_VirtualMachinePublishRequest(in *VirtualMachinePublishRequest, out *v1alpha2.VirtualMachinePublishRequest, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachinePublishRequest_To_v1alpha2_VirtualMachinePublishRequest(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachinePublishRequest_To_v1alpha1_VirtualMachinePublishRequest(in *v1alpha2.VirtualMachinePublishRequest, out *VirtualMachinePublishRequest, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1alpha2_VirtualMachinePublishRequestSpec_To_v1alpha1_VirtualMachinePublishRequestSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_v1alpha2_VirtualMachinePublishRequestStatus_To_v1alpha1_VirtualMachinePublishRequestStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha2_VirtualMachinePublishRequest_To_v1alpha1_VirtualMachinePublishRequest is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachinePublishRequest_To_v1alpha1_VirtualMachinePublishRequest(in *v1alpha2.VirtualMachinePublishRequest, out *VirtualMachinePublishRequest, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachinePublishRequest_To_v1alpha1_VirtualMachinePublishRequest(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachinePublishRequestList_To_v1alpha2_VirtualMachinePublishRequestList(in *VirtualMachinePublishRequestList, out *v1alpha2.VirtualMachinePublishRequestList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]v1alpha2.VirtualMachinePublishRequest, len(*in))
		for i := range *in {
			if err := Convert_v1alpha1_VirtualMachinePublishRequest_To_v1alpha2_VirtualMachinePublishRequest(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Items = nil
	}
	return nil
}

// Convert_v1alpha1_VirtualMachinePublishRequestList_To_v1alpha2_VirtualMachinePublishRequestList is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachinePublishRequestList_To_v1alpha2_VirtualMachinePublishRequestList(in *VirtualMachinePublishRequestList, out *v1alpha2.VirtualMachinePublishRequestList, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachinePublishRequestList_To_v1alpha2_VirtualMachinePublishRequestList(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachinePublishRequestList_To_v1alpha1_VirtualMachinePublishRequestList(in *v1alpha2.VirtualMachinePublishRequestList, out *VirtualMachinePublishRequestList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]VirtualMachinePublishRequest, len(*in))
		for i := range *in {
			if err := Convert_v1alpha2_VirtualMachinePublishRequest_To_v1alpha1_VirtualMachinePublishRequest(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Items = nil
	}
	return nil
}

// Convert_v1alpha2_VirtualMachinePublishRequestList_To_v1alpha1_VirtualMachinePublishRequestList is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachinePublishRequestList_To_v1alpha1_VirtualMachinePublishRequestList(in *v1alpha2.VirtualMachinePublishRequestList, out *VirtualMachinePublishRequestList, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachinePublishRequestList_To_v1alpha1_VirtualMachinePublishRequestList(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachinePublishRequestSource_To_v1alpha2_VirtualMachinePublishRequestSource(in *VirtualMachinePublishRequestSource, out *v1alpha2.VirtualMachinePublishRequestSource, s conversion.Scope) error {
	out.Name = in.Name
	out.APIVersion = in.APIVersion
	out.Kind = in.Kind
	return nil
}

// Convert_v1alpha1_VirtualMachinePublishRequestSource_To_v1alpha2_VirtualMachinePublishRequestSource is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachinePublishRequestSource_To_v1alpha2_VirtualMachinePublishRequestSource(in *VirtualMachinePublishRequestSource, out *v1alpha2.VirtualMachinePublishRequestSource, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachinePublishRequestSource_To_v1alpha2_VirtualMachinePublishRequestSource(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachinePublishRequestSource_To_v1alpha1_VirtualMachinePublishRequestSource(in *v1alpha2.VirtualMachinePublishRequestSource, out *VirtualMachinePublishRequestSource, s conversion.Scope) error {
	out.Name = in.Name
	out.APIVersion = in.APIVersion
	out.Kind = in.Kind
	return nil
}

// Convert_v1alpha2_VirtualMachinePublishRequestSource_To_v1alpha1_VirtualMachinePublishRequestSource is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachinePublishRequestSource_To_v1alpha1_VirtualMachinePublishRequestSource(in *v1alpha2.VirtualMachinePublishRequestSource, out *VirtualMachinePublishRequestSource, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachinePublishRequestSource_To_v1alpha1_VirtualMachinePublishRequestSource(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachinePublishRequestSpec_To_v1alpha2_VirtualMachinePublishRequestSpec(in *VirtualMachinePublishRequestSpec, out *v1alpha2.VirtualMachinePublishRequestSpec, s conversion.Scope) error {
	if err := Convert_v1alpha1_VirtualMachinePublishRequestSource_To_v1alpha2_VirtualMachinePublishRequestSource(&in.Source, &out.Source, s); err != nil {
		return err
	}
	if err := Convert_v1alpha1_VirtualMachinePublishRequestTarget_To_v1alpha2_VirtualMachinePublishRequestTarget(&in.Target, &out.Target, s); err != nil {
		return err
	}
	out.TTLSecondsAfterFinished = (*int64)(unsafe.Pointer(in.TTLSecondsAfterFinished))
	return nil
}

// Convert_v1alpha1_VirtualMachinePublishRequestSpec_To_v1alpha2_VirtualMachinePublishRequestSpec is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachinePublishRequestSpec_To_v1alpha2_VirtualMachinePublishRequestSpec(in *VirtualMachinePublishRequestSpec, out *v1alpha2.VirtualMachinePublishRequestSpec, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachinePublishRequestSpec_To_v1alpha2_VirtualMachinePublishRequestSpec(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachinePublishRequestSpec_To_v1alpha1_VirtualMachinePublishRequestSpec(in *v1alpha2.VirtualMachinePublishRequestSpec, out *VirtualMachinePublishRequestSpec, s conversion.Scope) error {
	if err := Convert_v1alpha2_VirtualMachinePublishRequestSource_To_v1alpha1_VirtualMachinePublishRequestSource(&in.Source, &out.Source, s); err != nil {
		return err
	}
	if err := Convert_v1alpha2_VirtualMachinePublishRequestTarget_To_v1alpha1_VirtualMachinePublishRequestTarget(&in.Target, &out.Target, s); err != nil {
		return err
	}
	out.TTLSecondsAfterFinished = (*int64)(unsafe.Pointer(in.TTLSecondsAfterFinished))
	return nil
}

// Convert_v1alpha2_VirtualMachinePublishRequestSpec_To_v1alpha1_VirtualMachinePublishRequestSpec is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachinePublishRequestSpec_To_v1alpha1_VirtualMachinePublishRequestSpec(in *v1alpha2.VirtualMachinePublishRequestSpec, out *VirtualMachinePublishRequestSpec, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachinePublishRequestSpec_To_v1alpha1_VirtualMachinePublishRequestSpec(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachinePublishRequestStatus_To_v1alpha2_VirtualMachinePublishRequestStatus(in *VirtualMachinePublishRequestStatus, out *v1alpha2.VirtualMachinePublishRequestStatus, s conversion.Scope) error {
	out.SourceRef = (*v1alpha2.VirtualMachinePublishRequestSource)(unsafe.Pointer(in.SourceRef))
	out.TargetRef = (*v1alpha2.VirtualMachinePublishRequestTarget)(unsafe.Pointer(in.TargetRef))
	out.CompletionTime = in.CompletionTime
	out.StartTime = in.StartTime
	out.Attempts = in.Attempts
	out.LastAttemptTime = in.LastAttemptTime
	out.ImageName = in.ImageName
	out.Ready = in.Ready
	if in.Conditions != nil {
		in, out := &in.Conditions, &out.Conditions
		*out = make([]v1.Condition, len(*in))
		for i := range *in {
			if err := Convert_v1alpha1_Condition_To_v1_Condition(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Conditions = nil
	}
	return nil
}

// Convert_v1alpha1_VirtualMachinePublishRequestStatus_To_v1alpha2_VirtualMachinePublishRequestStatus is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachinePublishRequestStatus_To_v1alpha2_VirtualMachinePublishRequestStatus(in *VirtualMachinePublishRequestStatus, out *v1alpha2.VirtualMachinePublishRequestStatus, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachinePublishRequestStatus_To_v1alpha2_VirtualMachinePublishRequestStatus(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachinePublishRequestStatus_To_v1alpha1_VirtualMachinePublishRequestStatus(in *v1alpha2.VirtualMachinePublishRequestStatus, out *VirtualMachinePublishRequestStatus, s conversion.Scope) error {
	out.SourceRef = (*VirtualMachinePublishRequestSource)(unsafe.Pointer(in.SourceRef))
	out.TargetRef = (*VirtualMachinePublishRequestTarget)(unsafe.Pointer(in.TargetRef))
	out.CompletionTime = in.CompletionTime
	out.StartTime = in.StartTime
	out.Attempts = in.Attempts
	out.LastAttemptTime = in.LastAttemptTime
	out.ImageName = in.ImageName
	out.Ready = in.Ready
	if in.Conditions != nil {
		in, out := &in.Conditions, &out.Conditions
		*out = make([]Condition, len(*in))
		for i := range *in {
			if err := Convert_v1_Condition_To_v1alpha1_Condition(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Conditions = nil
	}
	return nil
}

// Convert_v1alpha2_VirtualMachinePublishRequestStatus_To_v1alpha1_VirtualMachinePublishRequestStatus is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachinePublishRequestStatus_To_v1alpha1_VirtualMachinePublishRequestStatus(in *v1alpha2.VirtualMachinePublishRequestStatus, out *VirtualMachinePublishRequestStatus, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachinePublishRequestStatus_To_v1alpha1_VirtualMachinePublishRequestStatus(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachinePublishRequestTarget_To_v1alpha2_VirtualMachinePublishRequestTarget(in *VirtualMachinePublishRequestTarget, out *v1alpha2.VirtualMachinePublishRequestTarget, s conversion.Scope) error {
	if err := Convert_v1alpha1_VirtualMachinePublishRequestTargetItem_To_v1alpha2_VirtualMachinePublishRequestTargetItem(&in.Item, &out.Item, s); err != nil {
		return err
	}
	if err := Convert_v1alpha1_VirtualMachinePublishRequestTargetLocation_To_v1alpha2_VirtualMachinePublishRequestTargetLocation(&in.Location, &out.Location, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha1_VirtualMachinePublishRequestTarget_To_v1alpha2_VirtualMachinePublishRequestTarget is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachinePublishRequestTarget_To_v1alpha2_VirtualMachinePublishRequestTarget(in *VirtualMachinePublishRequestTarget, out *v1alpha2.VirtualMachinePublishRequestTarget, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachinePublishRequestTarget_To_v1alpha2_VirtualMachinePublishRequestTarget(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachinePublishRequestTarget_To_v1alpha1_VirtualMachinePublishRequestTarget(in *v1alpha2.VirtualMachinePublishRequestTarget, out *VirtualMachinePublishRequestTarget, s conversion.Scope) error {
	if err := Convert_v1alpha2_VirtualMachinePublishRequestTargetItem_To_v1alpha1_VirtualMachinePublishRequestTargetItem(&in.Item, &out.Item, s); err != nil {
		return err
	}
	if err := Convert_v1alpha2_VirtualMachinePublishRequestTargetLocation_To_v1alpha1_VirtualMachinePublishRequestTargetLocation(&in.Location, &out.Location, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha2_VirtualMachinePublishRequestTarget_To_v1alpha1_VirtualMachinePublishRequestTarget is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachinePublishRequestTarget_To_v1alpha1_VirtualMachinePublishRequestTarget(in *v1alpha2.VirtualMachinePublishRequestTarget, out *VirtualMachinePublishRequestTarget, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachinePublishRequestTarget_To_v1alpha1_VirtualMachinePublishRequestTarget(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachinePublishRequestTargetItem_To_v1alpha2_VirtualMachinePublishRequestTargetItem(in *VirtualMachinePublishRequestTargetItem, out *v1alpha2.VirtualMachinePublishRequestTargetItem, s conversion.Scope) error {
	out.Name = in.Name
	out.Description = in.Description
	return nil
}

// Convert_v1alpha1_VirtualMachinePublishRequestTargetItem_To_v1alpha2_VirtualMachinePublishRequestTargetItem is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachinePublishRequestTargetItem_To_v1alpha2_VirtualMachinePublishRequestTargetItem(in *VirtualMachinePublishRequestTargetItem, out *v1alpha2.VirtualMachinePublishRequestTargetItem, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachinePublishRequestTargetItem_To_v1alpha2_VirtualMachinePublishRequestTargetItem(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachinePublishRequestTargetItem_To_v1alpha1_VirtualMachinePublishRequestTargetItem(in *v1alpha2.VirtualMachinePublishRequestTargetItem, out *VirtualMachinePublishRequestTargetItem, s conversion.Scope) error {
	out.Name = in.Name
	out.Description = in.Description
	return nil
}

// Convert_v1alpha2_VirtualMachinePublishRequestTargetItem_To_v1alpha1_VirtualMachinePublishRequestTargetItem is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachinePublishRequestTargetItem_To_v1alpha1_VirtualMachinePublishRequestTargetItem(in *v1alpha2.VirtualMachinePublishRequestTargetItem, out *VirtualMachinePublishRequestTargetItem, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachinePublishRequestTargetItem_To_v1alpha1_VirtualMachinePublishRequestTargetItem(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachinePublishRequestTargetLocation_To_v1alpha2_VirtualMachinePublishRequestTargetLocation(in *VirtualMachinePublishRequestTargetLocation, out *v1alpha2.VirtualMachinePublishRequestTargetLocation, s conversion.Scope) error {
	out.Name = in.Name
	out.APIVersion = in.APIVersion
	out.Kind = in.Kind
	return nil
}

// Convert_v1alpha1_VirtualMachinePublishRequestTargetLocation_To_v1alpha2_VirtualMachinePublishRequestTargetLocation is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachinePublishRequestTargetLocation_To_v1alpha2_VirtualMachinePublishRequestTargetLocation(in *VirtualMachinePublishRequestTargetLocation, out *v1alpha2.VirtualMachinePublishRequestTargetLocation, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachinePublishRequestTargetLocation_To_v1alpha2_VirtualMachinePublishRequestTargetLocation(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachinePublishRequestTargetLocation_To_v1alpha1_VirtualMachinePublishRequestTargetLocation(in *v1alpha2.VirtualMachinePublishRequestTargetLocation, out *VirtualMachinePublishRequestTargetLocation, s conversion.Scope) error {
	out.Name = in.Name
	out.APIVersion = in.APIVersion
	out.Kind = in.Kind
	return nil
}

// Convert_v1alpha2_VirtualMachinePublishRequestTargetLocation_To_v1alpha1_VirtualMachinePublishRequestTargetLocation is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachinePublishRequestTargetLocation_To_v1alpha1_VirtualMachinePublishRequestTargetLocation(in *v1alpha2.VirtualMachinePublishRequestTargetLocation, out *VirtualMachinePublishRequestTargetLocation, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachinePublishRequestTargetLocation_To_v1alpha1_VirtualMachinePublishRequestTargetLocation(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineResourceSpec_To_v1alpha2_VirtualMachineResourceSpec(in *VirtualMachineResourceSpec, out *v1alpha2.VirtualMachineResourceSpec, s conversion.Scope) error {
	out.Cpu = in.Cpu
	out.Memory = in.Memory
	return nil
}

// Convert_v1alpha1_VirtualMachineResourceSpec_To_v1alpha2_VirtualMachineResourceSpec is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineResourceSpec_To_v1alpha2_VirtualMachineResourceSpec(in *VirtualMachineResourceSpec, out *v1alpha2.VirtualMachineResourceSpec, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineResourceSpec_To_v1alpha2_VirtualMachineResourceSpec(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineResourceSpec_To_v1alpha1_VirtualMachineResourceSpec(in *v1alpha2.VirtualMachineResourceSpec, out *VirtualMachineResourceSpec, s conversion.Scope) error {
	out.Cpu = in.Cpu
	out.Memory = in.Memory
	return nil
}

// Convert_v1alpha2_VirtualMachineResourceSpec_To_v1alpha1_VirtualMachineResourceSpec is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineResourceSpec_To_v1alpha1_VirtualMachineResourceSpec(in *v1alpha2.VirtualMachineResourceSpec, out *VirtualMachineResourceSpec, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineResourceSpec_To_v1alpha1_VirtualMachineResourceSpec(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineService_To_v1alpha2_VirtualMachineService(in *VirtualMachineService, out *v1alpha2.VirtualMachineService, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1alpha1_VirtualMachineServiceSpec_To_v1alpha2_VirtualMachineServiceSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_v1alpha1_VirtualMachineServiceStatus_To_v1alpha2_VirtualMachineServiceStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha1_VirtualMachineService_To_v1alpha2_VirtualMachineService is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineService_To_v1alpha2_VirtualMachineService(in *VirtualMachineService, out *v1alpha2.VirtualMachineService, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineService_To_v1alpha2_VirtualMachineService(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineService_To_v1alpha1_VirtualMachineService(in *v1alpha2.VirtualMachineService, out *VirtualMachineService, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1alpha2_VirtualMachineServiceSpec_To_v1alpha1_VirtualMachineServiceSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_v1alpha2_VirtualMachineServiceStatus_To_v1alpha1_VirtualMachineServiceStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha2_VirtualMachineService_To_v1alpha1_VirtualMachineService is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineService_To_v1alpha1_VirtualMachineService(in *v1alpha2.VirtualMachineService, out *VirtualMachineService, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineService_To_v1alpha1_VirtualMachineService(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineServiceList_To_v1alpha2_VirtualMachineServiceList(in *VirtualMachineServiceList, out *v1alpha2.VirtualMachineServiceList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]v1alpha2.VirtualMachineService)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_v1alpha1_VirtualMachineServiceList_To_v1alpha2_VirtualMachineServiceList is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineServiceList_To_v1alpha2_VirtualMachineServiceList(in *VirtualMachineServiceList, out *v1alpha2.VirtualMachineServiceList, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineServiceList_To_v1alpha2_VirtualMachineServiceList(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineServiceList_To_v1alpha1_VirtualMachineServiceList(in *v1alpha2.VirtualMachineServiceList, out *VirtualMachineServiceList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]VirtualMachineService)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_v1alpha2_VirtualMachineServiceList_To_v1alpha1_VirtualMachineServiceList is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineServiceList_To_v1alpha1_VirtualMachineServiceList(in *v1alpha2.VirtualMachineServiceList, out *VirtualMachineServiceList, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineServiceList_To_v1alpha1_VirtualMachineServiceList(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineServicePort_To_v1alpha2_VirtualMachineServicePort(in *VirtualMachineServicePort, out *v1alpha2.VirtualMachineServicePort, s conversion.Scope) error {
	out.Name = in.Name
	out.Protocol = in.Protocol
	out.Port = in.Port
	out.TargetPort = in.TargetPort
	return nil
}

// Convert_v1alpha1_VirtualMachineServicePort_To_v1alpha2_VirtualMachineServicePort is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineServicePort_To_v1alpha2_VirtualMachineServicePort(in *VirtualMachineServicePort, out *v1alpha2.VirtualMachineServicePort, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineServicePort_To_v1alpha2_VirtualMachineServicePort(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineServicePort_To_v1alpha1_VirtualMachineServicePort(in *v1alpha2.VirtualMachineServicePort, out *VirtualMachineServicePort, s conversion.Scope) error {
	out.Name = in.Name
	out.Protocol = in.Protocol
	out.Port = in.Port
	out.TargetPort = in.TargetPort
	return nil
}

// Convert_v1alpha2_VirtualMachineServicePort_To_v1alpha1_VirtualMachineServicePort is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineServicePort_To_v1alpha1_VirtualMachineServicePort(in *v1alpha2.VirtualMachineServicePort, out *VirtualMachineServicePort, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineServicePort_To_v1alpha1_VirtualMachineServicePort(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineServiceSpec_To_v1alpha2_VirtualMachineServiceSpec(in *VirtualMachineServiceSpec, out *v1alpha2.VirtualMachineServiceSpec, s conversion.Scope) error {
	out.Type = v1alpha2.VirtualMachineServiceType(in.Type)
	out.Ports = *(*[]v1alpha2.VirtualMachineServicePort)(unsafe.Pointer(&in.Ports))
	out.Selector = *(*map[string]string)(unsafe.Pointer(&in.Selector))
	out.LoadBalancerIP = in.LoadBalancerIP
	out.LoadBalancerSourceRanges = *(*[]string)(unsafe.Pointer(&in.LoadBalancerSourceRanges))
	out.ClusterIP = in.ClusterIP
	out.ExternalName = in.ExternalName
	return nil
}

// Convert_v1alpha1_VirtualMachineServiceSpec_To_v1alpha2_VirtualMachineServiceSpec is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineServiceSpec_To_v1alpha2_VirtualMachineServiceSpec(in *VirtualMachineServiceSpec, out *v1alpha2.VirtualMachineServiceSpec, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineServiceSpec_To_v1alpha2_VirtualMachineServiceSpec(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineServiceSpec_To_v1alpha1_VirtualMachineServiceSpec(in *v1alpha2.VirtualMachineServiceSpec, out *VirtualMachineServiceSpec, s conversion.Scope) error {
	out.Type = VirtualMachineServiceType(in.Type)
	out.Ports = *(*[]VirtualMachineServicePort)(unsafe.Pointer(&in.Ports))
	out.Selector = *(*map[string]string)(unsafe.Pointer(&in.Selector))
	out.LoadBalancerIP = in.LoadBalancerIP
	out.LoadBalancerSourceRanges = *(*[]string)(unsafe.Pointer(&in.LoadBalancerSourceRanges))
	out.ClusterIP = in.ClusterIP
	out.ExternalName = in.ExternalName
	return nil
}

// Convert_v1alpha2_VirtualMachineServiceSpec_To_v1alpha1_VirtualMachineServiceSpec is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineServiceSpec_To_v1alpha1_VirtualMachineServiceSpec(in *v1alpha2.VirtualMachineServiceSpec, out *VirtualMachineServiceSpec, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineServiceSpec_To_v1alpha1_VirtualMachineServiceSpec(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineServiceStatus_To_v1alpha2_VirtualMachineServiceStatus(in *VirtualMachineServiceStatus, out *v1alpha2.VirtualMachineServiceStatus, s conversion.Scope) error {
	if err := Convert_v1alpha1_LoadBalancerStatus_To_v1alpha2_LoadBalancerStatus(&in.LoadBalancer, &out.LoadBalancer, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha1_VirtualMachineServiceStatus_To_v1alpha2_VirtualMachineServiceStatus is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineServiceStatus_To_v1alpha2_VirtualMachineServiceStatus(in *VirtualMachineServiceStatus, out *v1alpha2.VirtualMachineServiceStatus, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineServiceStatus_To_v1alpha2_VirtualMachineServiceStatus(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineServiceStatus_To_v1alpha1_VirtualMachineServiceStatus(in *v1alpha2.VirtualMachineServiceStatus, out *VirtualMachineServiceStatus, s conversion.Scope) error {
	if err := Convert_v1alpha2_LoadBalancerStatus_To_v1alpha1_LoadBalancerStatus(&in.LoadBalancer, &out.LoadBalancer, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha2_VirtualMachineServiceStatus_To_v1alpha1_VirtualMachineServiceStatus is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineServiceStatus_To_v1alpha1_VirtualMachineServiceStatus(in *v1alpha2.VirtualMachineServiceStatus, out *VirtualMachineServiceStatus, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineServiceStatus_To_v1alpha1_VirtualMachineServiceStatus(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineSetResourcePolicy_To_v1alpha2_VirtualMachineSetResourcePolicy(in *VirtualMachineSetResourcePolicy, out *v1alpha2.VirtualMachineSetResourcePolicy, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1alpha1_VirtualMachineSetResourcePolicySpec_To_v1alpha2_VirtualMachineSetResourcePolicySpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_v1alpha1_VirtualMachineSetResourcePolicyStatus_To_v1alpha2_VirtualMachineSetResourcePolicyStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha1_VirtualMachineSetResourcePolicy_To_v1alpha2_VirtualMachineSetResourcePolicy is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineSetResourcePolicy_To_v1alpha2_VirtualMachineSetResourcePolicy(in *VirtualMachineSetResourcePolicy, out *v1alpha2.VirtualMachineSetResourcePolicy, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineSetResourcePolicy_To_v1alpha2_VirtualMachineSetResourcePolicy(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineSetResourcePolicy_To_v1alpha1_VirtualMachineSetResourcePolicy(in *v1alpha2.VirtualMachineSetResourcePolicy, out *VirtualMachineSetResourcePolicy, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1alpha2_VirtualMachineSetResourcePolicySpec_To_v1alpha1_VirtualMachineSetResourcePolicySpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_v1alpha2_VirtualMachineSetResourcePolicyStatus_To_v1alpha1_VirtualMachineSetResourcePolicyStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha2_VirtualMachineSetResourcePolicy_To_v1alpha1_VirtualMachineSetResourcePolicy is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineSetResourcePolicy_To_v1alpha1_VirtualMachineSetResourcePolicy(in *v1alpha2.VirtualMachineSetResourcePolicy, out *VirtualMachineSetResourcePolicy, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineSetResourcePolicy_To_v1alpha1_VirtualMachineSetResourcePolicy(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineSetResourcePolicyList_To_v1alpha2_VirtualMachineSetResourcePolicyList(in *VirtualMachineSetResourcePolicyList, out *v1alpha2.VirtualMachineSetResourcePolicyList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]v1alpha2.VirtualMachineSetResourcePolicy, len(*in))
		for i := range *in {
			if err := Convert_v1alpha1_VirtualMachineSetResourcePolicy_To_v1alpha2_VirtualMachineSetResourcePolicy(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Items = nil
	}
	return nil
}

// Convert_v1alpha1_VirtualMachineSetResourcePolicyList_To_v1alpha2_VirtualMachineSetResourcePolicyList is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineSetResourcePolicyList_To_v1alpha2_VirtualMachineSetResourcePolicyList(in *VirtualMachineSetResourcePolicyList, out *v1alpha2.VirtualMachineSetResourcePolicyList, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineSetResourcePolicyList_To_v1alpha2_VirtualMachineSetResourcePolicyList(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineSetResourcePolicyList_To_v1alpha1_VirtualMachineSetResourcePolicyList(in *v1alpha2.VirtualMachineSetResourcePolicyList, out *VirtualMachineSetResourcePolicyList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]VirtualMachineSetResourcePolicy, len(*in))
		for i := range *in {
			if err := Convert_v1alpha2_VirtualMachineSetResourcePolicy_To_v1alpha1_VirtualMachineSetResourcePolicy(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Items = nil
	}
	return nil
}

// Convert_v1alpha2_VirtualMachineSetResourcePolicyList_To_v1alpha1_VirtualMachineSetResourcePolicyList is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineSetResourcePolicyList_To_v1alpha1_VirtualMachineSetResourcePolicyList(in *v1alpha2.VirtualMachineSetResourcePolicyList, out *VirtualMachineSetResourcePolicyList, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineSetResourcePolicyList_To_v1alpha1_VirtualMachineSetResourcePolicyList(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineSetResourcePolicySpec_To_v1alpha2_VirtualMachineSetResourcePolicySpec(in *VirtualMachineSetResourcePolicySpec, out *v1alpha2.VirtualMachineSetResourcePolicySpec, s conversion.Scope) error {
	if err := Convert_v1alpha1_ResourcePoolSpec_To_v1alpha2_ResourcePoolSpec(&in.ResourcePool, &out.ResourcePool, s); err != nil {
		return err
	}
	// WARNING: in.Folder requires manual conversion: inconvertible types (github.com/vmware-tanzu/vm-operator/api/v1alpha1.FolderSpec vs string)
	// WARNING: in.ClusterModules requires manual conversion: does not exist in peer-type
	return nil
}

func autoConvert_v1alpha2_VirtualMachineSetResourcePolicySpec_To_v1alpha1_VirtualMachineSetResourcePolicySpec(in *v1alpha2.VirtualMachineSetResourcePolicySpec, out *VirtualMachineSetResourcePolicySpec, s conversion.Scope) error {
	if err := Convert_v1alpha2_ResourcePoolSpec_To_v1alpha1_ResourcePoolSpec(&in.ResourcePool, &out.ResourcePool, s); err != nil {
		return err
	}
	// WARNING: in.Folder requires manual conversion: inconvertible types (string vs github.com/vmware-tanzu/vm-operator/api/v1alpha1.FolderSpec)
	// WARNING: in.ClusterModuleGroups requires manual conversion: does not exist in peer-type
	return nil
}

func autoConvert_v1alpha1_VirtualMachineSetResourcePolicyStatus_To_v1alpha2_VirtualMachineSetResourcePolicyStatus(in *VirtualMachineSetResourcePolicyStatus, out *v1alpha2.VirtualMachineSetResourcePolicyStatus, s conversion.Scope) error {
	out.ClusterModules = *(*[]v1alpha2.VSphereClusterModuleStatus)(unsafe.Pointer(&in.ClusterModules))
	return nil
}

// Convert_v1alpha1_VirtualMachineSetResourcePolicyStatus_To_v1alpha2_VirtualMachineSetResourcePolicyStatus is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineSetResourcePolicyStatus_To_v1alpha2_VirtualMachineSetResourcePolicyStatus(in *VirtualMachineSetResourcePolicyStatus, out *v1alpha2.VirtualMachineSetResourcePolicyStatus, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineSetResourcePolicyStatus_To_v1alpha2_VirtualMachineSetResourcePolicyStatus(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineSetResourcePolicyStatus_To_v1alpha1_VirtualMachineSetResourcePolicyStatus(in *v1alpha2.VirtualMachineSetResourcePolicyStatus, out *VirtualMachineSetResourcePolicyStatus, s conversion.Scope) error {
	out.ClusterModules = *(*[]ClusterModuleStatus)(unsafe.Pointer(&in.ClusterModules))
	return nil
}

// Convert_v1alpha2_VirtualMachineSetResourcePolicyStatus_To_v1alpha1_VirtualMachineSetResourcePolicyStatus is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineSetResourcePolicyStatus_To_v1alpha1_VirtualMachineSetResourcePolicyStatus(in *v1alpha2.VirtualMachineSetResourcePolicyStatus, out *VirtualMachineSetResourcePolicyStatus, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineSetResourcePolicyStatus_To_v1alpha1_VirtualMachineSetResourcePolicyStatus(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineSpec_To_v1alpha2_VirtualMachineSpec(in *VirtualMachineSpec, out *v1alpha2.VirtualMachineSpec, s conversion.Scope) error {
	out.ImageName = in.ImageName
	out.ClassName = in.ClassName
	out.PowerState = v1alpha2.VirtualMachinePowerState(in.PowerState)
	// WARNING: in.Ports requires manual conversion: does not exist in peer-type
	// WARNING: in.VmMetadata requires manual conversion: does not exist in peer-type
	out.StorageClass = in.StorageClass
	// WARNING: in.NetworkInterfaces requires manual conversion: does not exist in peer-type
	// WARNING: in.ResourcePolicyName requires manual conversion: does not exist in peer-type
	if in.Volumes != nil {
		in, out := &in.Volumes, &out.Volumes
		*out = make([]v1alpha2.VirtualMachineVolume, len(*in))
		for i := range *in {
			if err := Convert_v1alpha1_VirtualMachineVolume_To_v1alpha2_VirtualMachineVolume(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Volumes = nil
	}
	// WARNING: in.ReadinessProbe requires manual conversion: inconvertible types (*github.com/vmware-tanzu/vm-operator/api/v1alpha1.Probe vs github.com/vmware-tanzu/vm-operator/api/v1alpha2.VirtualMachineReadinessProbeSpec)
	// WARNING: in.AdvancedOptions requires manual conversion: does not exist in peer-type
	return nil
}

func autoConvert_v1alpha2_VirtualMachineSpec_To_v1alpha1_VirtualMachineSpec(in *v1alpha2.VirtualMachineSpec, out *VirtualMachineSpec, s conversion.Scope) error {
	out.ImageName = in.ImageName
	out.ClassName = in.ClassName
	out.StorageClass = in.StorageClass
	// WARNING: in.Bootstrap requires manual conversion: does not exist in peer-type
	// WARNING: in.Network requires manual conversion: does not exist in peer-type
	out.PowerState = VirtualMachinePowerState(in.PowerState)
	if in.Volumes != nil {
		in, out := &in.Volumes, &out.Volumes
		*out = make([]VirtualMachineVolume, len(*in))
		for i := range *in {
			if err := Convert_v1alpha2_VirtualMachineVolume_To_v1alpha1_VirtualMachineVolume(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Volumes = nil
	}
	// WARNING: in.ReadinessProbe requires manual conversion: inconvertible types (github.com/vmware-tanzu/vm-operator/api/v1alpha2.VirtualMachineReadinessProbeSpec vs *github.com/vmware-tanzu/vm-operator/api/v1alpha1.Probe)
	// WARNING: in.ReadinessGates requires manual conversion: does not exist in peer-type
	// WARNING: in.Advanced requires manual conversion: does not exist in peer-type
	// WARNING: in.Reserved requires manual conversion: does not exist in peer-type
	return nil
}

func autoConvert_v1alpha1_VirtualMachineStatus_To_v1alpha2_VirtualMachineStatus(in *VirtualMachineStatus, out *v1alpha2.VirtualMachineStatus, s conversion.Scope) error {
	out.Host = in.Host
	out.PowerState = v1alpha2.VirtualMachinePowerState(in.PowerState)
	// WARNING: in.Phase requires manual conversion: does not exist in peer-type
	if in.Conditions != nil {
		in, out := &in.Conditions, &out.Conditions
		*out = make([]v1.Condition, len(*in))
		for i := range *in {
			if err := Convert_v1alpha1_Condition_To_v1_Condition(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Conditions = nil
	}
	// WARNING: in.VmIp requires manual conversion: does not exist in peer-type
	out.UniqueID = in.UniqueID
	out.BiosUUID = in.BiosUUID
	out.InstanceUUID = in.InstanceUUID
	if in.Volumes != nil {
		in, out := &in.Volumes, &out.Volumes
		*out = make([]v1alpha2.VirtualMachineVolumeStatus, len(*in))
		for i := range *in {
			if err := Convert_v1alpha1_VirtualMachineVolumeStatus_To_v1alpha2_VirtualMachineVolumeStatus(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Volumes = nil
	}
	out.ChangeBlockTracking = (*bool)(unsafe.Pointer(in.ChangeBlockTracking))
	// WARNING: in.NetworkInterfaces requires manual conversion: does not exist in peer-type
	out.Zone = in.Zone
	return nil
}

func autoConvert_v1alpha2_VirtualMachineStatus_To_v1alpha1_VirtualMachineStatus(in *v1alpha2.VirtualMachineStatus, out *VirtualMachineStatus, s conversion.Scope) error {
	// WARNING: in.Image requires manual conversion: does not exist in peer-type
	// WARNING: in.Class requires manual conversion: does not exist in peer-type
	out.Host = in.Host
	out.PowerState = VirtualMachinePowerState(in.PowerState)
	if in.Conditions != nil {
		in, out := &in.Conditions, &out.Conditions
		*out = make([]Condition, len(*in))
		for i := range *in {
			if err := Convert_v1_Condition_To_v1alpha1_Condition(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Conditions = nil
	}
	// WARNING: in.Network requires manual conversion: does not exist in peer-type
	out.UniqueID = in.UniqueID
	out.BiosUUID = in.BiosUUID
	out.InstanceUUID = in.InstanceUUID
	if in.Volumes != nil {
		in, out := &in.Volumes, &out.Volumes
		*out = make([]VirtualMachineVolumeStatus, len(*in))
		for i := range *in {
			if err := Convert_v1alpha2_VirtualMachineVolumeStatus_To_v1alpha1_VirtualMachineVolumeStatus(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Volumes = nil
	}
	out.ChangeBlockTracking = (*bool)(unsafe.Pointer(in.ChangeBlockTracking))
	out.Zone = in.Zone
	return nil
}

func autoConvert_v1alpha1_VirtualMachineTemplate_To_v1alpha2_VirtualMachineTemplate(in *VirtualMachineTemplate, out *v1alpha2.VirtualMachineTemplate, s conversion.Scope) error {
	if err := Convert_v1alpha1_NetworkStatus_To_v1alpha2_NetworkStatus(&in.Net, &out.Net, s); err != nil {
		return err
	}
	if in.VM != nil {
		in, out := &in.VM, &out.VM
		*out = new(v1alpha2.VirtualMachine)
		if err := Convert_v1alpha1_VirtualMachine_To_v1alpha2_VirtualMachine(*in, *out, s); err != nil {
			return err
		}
	} else {
		out.VM = nil
	}
	return nil
}

// Convert_v1alpha1_VirtualMachineTemplate_To_v1alpha2_VirtualMachineTemplate is an autogenerated conversion function.
func Convert_v1alpha1_VirtualMachineTemplate_To_v1alpha2_VirtualMachineTemplate(in *VirtualMachineTemplate, out *v1alpha2.VirtualMachineTemplate, s conversion.Scope) error {
	return autoConvert_v1alpha1_VirtualMachineTemplate_To_v1alpha2_VirtualMachineTemplate(in, out, s)
}

func autoConvert_v1alpha2_VirtualMachineTemplate_To_v1alpha1_VirtualMachineTemplate(in *v1alpha2.VirtualMachineTemplate, out *VirtualMachineTemplate, s conversion.Scope) error {
	if err := Convert_v1alpha2_NetworkStatus_To_v1alpha1_NetworkStatus(&in.Net, &out.Net, s); err != nil {
		return err
	}
	if in.VM != nil {
		in, out := &in.VM, &out.VM
		*out = new(VirtualMachine)
		if err := Convert_v1alpha2_VirtualMachine_To_v1alpha1_VirtualMachine(*in, *out, s); err != nil {
			return err
		}
	} else {
		out.VM = nil
	}
	return nil
}

// Convert_v1alpha2_VirtualMachineTemplate_To_v1alpha1_VirtualMachineTemplate is an autogenerated conversion function.
func Convert_v1alpha2_VirtualMachineTemplate_To_v1alpha1_VirtualMachineTemplate(in *v1alpha2.VirtualMachineTemplate, out *VirtualMachineTemplate, s conversion.Scope) error {
	return autoConvert_v1alpha2_VirtualMachineTemplate_To_v1alpha1_VirtualMachineTemplate(in, out, s)
}

func autoConvert_v1alpha1_VirtualMachineVolume_To_v1alpha2_VirtualMachineVolume(in *VirtualMachineVolume, out *v1alpha2.VirtualMachineVolume, s conversion.Scope) error {
	out.Name = in.Name
	// WARNING: in.PersistentVolumeClaim requires manual conversion: does not exist in peer-type
	// WARNING: in.VsphereVolume requires manual conversion: does not exist in peer-type
	return nil
}

func autoConvert_v1alpha2_VirtualMachineVolume_To_v1alpha1_VirtualMachineVolume(in *v1alpha2.VirtualMachineVolume, out *VirtualMachineVolume, s conversion.Scope) error {
	out.Name = in.Name
	// WARNING: in.VirtualMachineVolumeSource requires manual conversion: does not exist in peer-type
	return nil
}

func autoConvert_v1alpha1_VirtualMachineVolumeProvisioningOptions_To_v1alpha2_VirtualMachineVolumeProvisioningOptions(in *VirtualMachineVolumeProvisioningOptions, out *v1alpha2.VirtualMachineVolumeProvisioningOptions, s conversion.Scope) error {
	// WARNING: in.ThinProvisioned requires manual conversion: does not exist in peer-type
	// WARNING: in.EagerZeroed requires manual conversion: does not exist in peer-type
	return nil
}

func autoConvert_v1alpha2_VirtualMachineVolumeProvisioningOptions_To_v1alpha1_VirtualMachineVolumeProvisioningOptions(in *v1alpha2.VirtualMachineVolumeProvisioningOptions, out *VirtualMachineVolumeProvisioningOptions, s conversion.Scope) error {
	// WARNING: in.ThinProvision requires manual conversion: does not exist in peer-type
	// WARNING: in.EagerZero requires manual conversion: does not exist in peer-type
	return nil
}

func autoConvert_v1alpha1_VirtualMachineVolumeStatus_To_v1alpha2_VirtualMachineVolumeStatus(in *VirtualMachineVolumeStatus, out *v1alpha2.VirtualMachineVolumeStatus, s conversion.Scope) error {
	out.Name = in.Name
	out.Attached = in.Attached
	// WARNING: in.DiskUuid requires manual conversion: does not exist in peer-type
	out.Error = in.Error
	return nil
}

func autoConvert_v1alpha2_VirtualMachineVolumeStatus_To_v1alpha1_VirtualMachineVolumeStatus(in *v1alpha2.VirtualMachineVolumeStatus, out *VirtualMachineVolumeStatus, s conversion.Scope) error {
	out.Name = in.Name
	out.Attached = in.Attached
	// WARNING: in.DiskUUID requires manual conversion: does not exist in peer-type
	out.Error = in.Error
	return nil
}
